/*
---------------------------------------------------------------------------
|					Runtime assembler compilation
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

#include "Library.h"
#include "AsmObj.h"

//---------------------------------------------------------------------------

void AsmObj::Reset()
{
	if (!HasMem)
	{
		fdata=(byte *)VirtualAlloc(NULL,ASMOBJSTARTSIZE ,MEM_RESERVE,PAGE_EXECUTE_READWRITE);
		fdata=(byte *)VirtualAlloc(fdata,ASMOBJSTARTSIZE,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
		assert(fdata!=NULL);
		HasMem=true;
	}
	IsOverflow=false;IsCompiled=false;FinalSize=0;DataOffset=0;
}

//---------------------------------------------------------------------------

void AsmObj::Done()
{
	if (!IsOverflow)IsCompiled=true;
	else IsCompiled=false;
	FinalSize=DataOffset;DataOffset=0;
}

//---------------------------------------------------------------------------

AsmObj::AsmObj()
{
	HasMem=false;
	IsCompiled=false;FinalSize=0;DataOffset=0;
};

//---------------------------------------------------------------------------

AsmObj::~AsmObj()
{
	if (HasMem)VirtualFree(fdata,0,MEM_RELEASE);
};

//---------------------------------------------------------------------------

