/*
---------------------------------------------------------------------------
|			   Chain class. used for linked chains
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:
Changes:
	07-08-1998	Initial file setup
*/

#ifndef _H_CLASSCHAIN
#define _H_CLASSCHAIN

class  _Cchain{
	public:

	// Constructor. Pass previous and next elements to place new object in the chain
	_Cchain(_Cchain *i_prev=NULL,_Cchain *i_next=NULL);
	virtual ~_Cchain();

	void unlink();										// Removes the object from the chain, and tidies up the links of its neigbours
	void link(_Cchain *i_prev,_Cchain *i_next=NULL);	// Adds an existing object to the chain (see constructor)
	void move(_Cchain *i_prev,_Cchain *i_next=NULL);	// Combination of unlink and link
	void moveprev(_Cchain *i_prev);
	void slide(bool up=false);
	void move_to_bottom();								// Combination of unlink and link
	_Cchain *enumelem(short *num);						// Finds element number num in the chain, if *num is too great, NULL will be returned
														// And num will be the last element in the list.
														// If num==-1 the last element in the list will be returned.
	_Cchain *enumelem(short num);						// Identical, except no pointer is required
	short enumelem(_Cchain *d);
	void delete_chain();								// deletes all objects connected . including this
	void delete_links();								// deletes all objects connected .. not this itself

	_Cchain *prev;
	_Cchain *next;
};

//---------------------------------------------------------------------------
// Generic list of _cbase objects
class  DataChain:public _Cchain 
{
	public:
	DataChain(_Cchain *i_prev=NULL):_Cchain(i_prev){}
	virtual ~DataChain(){};
	void *data; 
};


#endif