/*
---------------------------------------------------------------------------
|		 			  Dialog helper functions
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:

Changes:
*/

#include "Library.h"
#include "ClassDialogTool.h" 
#include "DialogManager.h"

//------------------------------------------------------------------
// For the opentimer function
long TimerID=-1;

bool CDialogTool::DialogNoLoadSize=false;

class  _TimerList:public _Cchain 
{
	public:
	_TimerList(_Cchain *i_prev=NULL):_Cchain(i_prev){}
	~_TimerList(){};

	long ID;
	CDialogTool *window; 
}TimerList;

//---------------------------------------------------------------------------

class MessageElement
{
public:
	CDialogTool *window;
	long	    msgID; // to what it responds
};
List<MessageElement> MessageList;

//---------------------------------------------------------------------------
// Constructor
CDialogTool::CDialogTool(short ID,CWnd* pParent):
			 CDialog(ID,pParent)
{
	lastframe=0;
//	dmanager=NULL;
	framedlg=NULL;
	InitTimerID=-1;
	SizeMessagesActive  =false;
	SizeMessagesStarting=true;
	GetSetObject=NULL;
	UpdatingControl=false;
}

//---------------------------------------------------------------------------

CDialogTool::~CDialogTool()
{

	SizeData.delete_links();
}

// ---------------------------------------------------------------

void CDialogTool::CreateDlg(long IDD,CWnd *pParent/*, bool addtodesktop*/)
{
	Create(IDD,GetDesktopWindow());
	if (pParent!=NULL)
		::SetParent(m_hWnd,pParent->m_hWnd);
	else
		::SetParent(m_hWnd,NULL);
}


// ---------------------------------------------------------------

void CDialogTool::ShutdownDialog()
{
	CloseDlg();
}

// ---------------------------------------------------------------

void CDialogTool::CloseDlg()
{
	//CloseTimer();
	//RemoveFromDesktop();
	//if (dmanager!=NULL)
	//	((DialogManager *)dmanager)->RemoveWindow(this);

	RemoveFromMsgList();
	RemoveFromTimer();
	DestroyWindow();
	delete this;
}

// ---------------------------------------------------------------

void CDialogTool::SizeControl(CWnd *obj,short x,short y,float xf1,float yf1,float xf2,float yf2,bool redraw)
{
	_SizeData *o;
	o=(_SizeData *)SizeData.next;
	while (o!=NULL)
	{
		if (o->control==obj)break;
		o=(_SizeData *)o->next;
	}
	if (o==NULL)
	{
		o=new _SizeData(&SizeData);
		o->control=obj;
		obj->GetWindowRect(&o->rect);
		ScreenToClient(&o->rect);
		o->Origin[0].x=x-o->rect.left;
		o->Origin[0].y=y-o->rect.top;
		o->Origin[1].x=x-o->rect.right;
		o->Origin[1].y=y-o->rect.bottom;
	}
	else
	{
		short x1=(short)(o->rect.left	+(float)( (x-o->rect.left)  - o->Origin[0].x )*xf1   );
		short y1=(short)(o->rect.top	+(float)( (y-o->rect.top)   - o->Origin[0].y )*yf1   );
		short x2=(short)(o->rect.right	+(float)( (x-o->rect.right) - o->Origin[1].x )*xf2-x1);
		short y2=(short)(o->rect.bottom	+(float)( (y-o->rect.bottom)- o->Origin[1].y )*yf2-y1);
		obj->MoveWindow(x1,y1,x2, y2,redraw);	
	}
}

// ---------------------------------------------------------------

void CDialogTool::SizeControlStart()
{
	SizeMessagesActive=true;
	CRect c;GetClientRect(&c);
	SendMessage(WM_SIZE,SIZE_RESTORED,MAKEWPARAM(c.right,c.bottom));
}

// ---------------------------------------------------------------
float CDialogTool::GetValue(CWnd *obj,float step,float min,bool limmin,float max,bool limmax)
{
	if (UpdatingControl==true)return(UpdatingValue);
	float rval=min;
	String t;t.GetWnd(obj);
	rval=(float)t.Eval();		// bit overkill.. but cool ;)
	if (step!=0)rval=fix(rval,step);
	if(limmin==true && rval<min)rval=min;
	if(limmax==true && rval>max)rval=max;
	return(rval);
}

// ---------------------------------------------------------------

float CDialogTool::GetValueLim(CWnd *obj,float step,float min,bool limmin,float max,bool limmax,short commas)
{
	if (UpdatingControl==true)return(UpdatingValue);
	float rval=min,inval;
	String t;t.GetWnd(obj);
	inval=rval=(float)t.Eval();		// bit overkill.. but cool ;)
	// clip the bastard
	if (step!=0)rval=fix(rval,step);
	if(limmin==true && rval<min)rval=min;
	if(limmax==true && rval>max)rval=max;
	if ( inval!=rval )
	{
		UpdatingValue=rval;UpdatingControl=true;
		SetValue(obj,rval,commas);
		UpdatingControl=false;
	}
	return(rval);
}

// ---------------------------------------------------------------

void CDialogTool::SetValue(CWnd *obj,float val,short commas)
{
	if (UpdatingControl==false)
	{
		String t,f;
		f.Format("%%.%df",commas);
		t.Format(f,val);
		UpdatingValue=val;UpdatingControl=true;
		t.SetWnd(obj);
		obj->RedrawWindow();
		UpdatingControl=false;
	}
}

// ---------------------------------------------------------------

void CDialogTool::SetValueLim(CWnd *obj,float val,float step,float min,bool limmin,float max,bool limmax,short commas)
{
	// clip the bastard
	if (step!=0)val=fix(val,step);
	if(limmin==true && val<min)val=min;
	if(limmax==true && val>max)val=max;
	SetValue(obj,val,commas);
}

// ---------------------------------------------------------------

void  CDialogTool::SetText(CWnd *obj,char *text)
{
	if (UpdatingControl==false)
	{
		UpdatingControl=true;
		obj->SetWindowText(text);
		UpdatingControl=false;
	}
}

// ---------------------------------------------------------------

void CDialogTool::SetBool(CButton *obj,bool state)
{
	if (UpdatingControl==false)
	{
		UpdatingControl=true;
		if (state==true)obj->SetCheck(1);
		else obj->SetCheck(0);
		UpdatingControl=false;
	}
}

// ---------------------------------------------------------------

bool CDialogTool::GetBool(CButton *obj)
{
	if (obj->GetCheck()==1)return(true);
	return(false);
}

// ---------------------------------------------------------------

void CDialogTool::TopWindow()
{
//	if (dmanager!=NULL && framedlg==NULL)((DialogManager *)dmanager)->FindWindow(this,true);
	if (framedlg!=NULL)((CDialogTool *)framedlg)->SetActiveWindow();
	else SetActiveWindow();	
}; // calls cwnd::SetActiveWindow.. to set the window to the top.

// ---------------------------------------------------------------
// TODO fix for dual screen 

void CDialogTool::MakeWrapped(CPoint *p)
{
		ClientToScreen(p);
		long maxysize=GetSystemMetrics(SM_CYSCREEN);
		long maxxsize=GetSystemMetrics(SM_CXSCREEN);
		if (p->y<1){SetCursorPos(p->x,maxysize-2);ywrap-=1;p->y=maxysize-2;}
		if (p->y>maxysize-2){SetCursorPos(p->x,2);ywrap+=1;p->y=2;}
		if (p->x<1){SetCursorPos(maxxsize-2,p->y);xwrap-=1;p->x=maxxsize-2;}
		if (p->x>maxxsize-2){SetCursorPos(2,p->y);xwrap+=1;p->x=2;}
		p->x+=xwrap*maxxsize,p->y+=ywrap*maxysize;
}

// ---------------------------------------------------------------

void CDialogTool::ResetWrap()
{
		xwrap=0;
		ywrap=0;
}

// ---------------------------------------------------------------

void CDialogTool::ShowWin()
{
	windowisvisible=true;	
	ShowWindow(SW_SHOW);
	//if (winptr_desktopviewer!=NULL)
		//((CDialogTool *)winptr_desktopviewer)->message_handler(_DTMSG_UPDATE);
}

// ---------------------------------------------------------------

void CDialogTool::HideWin()
{
	windowisvisible=false;
	ShowWindow(SW_HIDE);
	//if (winptr_desktopviewer!=NULL)
	//	((CDialogTool *)winptr_desktopviewer)->message_handler(_DTMSG_UPDATE);
}

// ---------------------------------------------------------------

bool CDialogTool::ToggleWin(CWnd *win)
{
	if (win==NULL)win=this;
	if ((win->GetStyle()&WS_VISIBLE)==0)
	{
		win->ShowWindow(SW_SHOW);
		//if (winptr_desktopviewer!=NULL)
		//	((CDialogTool *)winptr_desktopviewer)->message_handler(_DTMSG_UPDATE);
		return(true);
	}
	else 
	{
		win->ShowWindow(SW_HIDE);
		//if (winptr_desktopviewer!=NULL)
		//	((CDialogTool *)winptr_desktopviewer)->message_handler(_DTMSG_UPDATE);
		return(false);
	}
}

// ---------------------------------------------------------------
// Timer shit
bool CDialogTool::OpenTimer(long timeout)
{
	InitTimerID=SetTimer(TimerID,timeout,NULL);
	if(InitTimerID==0)InitTimerID=-1;
	TimerID++;
	return(true);
}

// ---------------------------------------------------------------

void CDialogTool::CloseTimer()
{
	if (InitTimerID!=-1)
		KillTimer(InitTimerID);
	InitTimerID=-1;
}

// ---------------------------------------------------------------
// Default message handler

long CDialogTool::message_handler(long msg,long dta1,long dta2)
{
	switch(msg)
	{
		case _DTMSG_CLOSE:   
			ToggleWin();
			break;
		default:
		break;
	}
	return(0);
}

// ---------------------------------------------------------------

rArchive operator<<(rArchive arc, rCDialogTool b) // starting point for serialization
{
	WINDOWPLACEMENT p;
	b.GetWindowPlacement(&p);
	short visible=1;if (b.IsWindowVisible()==TRUE)visible=0;

	arc<<visible<<(long)p.showCmd<<p.ptMinPosition.x<<p.ptMinPosition.y;
	arc<<p.ptMaxPosition.x<<p.ptMaxPosition.y;
	arc<<p.rcNormalPosition.left<<p.rcNormalPosition.top;
	arc<<p.rcNormalPosition.bottom<<p.rcNormalPosition.right;

	return(arc);
}

// ---------------------------------------------------------------

rArchive operator>>(rArchive arc, rCDialogTool b)
{
	WINDOWPLACEMENT p;
	short visible;
	long l;
	arc>>visible>>l>>p.ptMinPosition.x>>p.ptMinPosition.y;p.showCmd=l;
	arc>>p.ptMaxPosition.x>>p.ptMaxPosition.y;
	arc>>p.rcNormalPosition.left>>p.rcNormalPosition.top;
	arc>>p.rcNormalPosition.bottom>>p.rcNormalPosition.right;

	b.SetWindowPlacement(&p);	
	return(arc);
}

// ---------------------------------------------------------------

void CDialogTool::SaveWindowPosition(const char *id)
{
	WINDOWPLACEMENT p;
	GetWindowPlacement(&p);
	String section;section.Format("WinPos%s",id);

	short visible=1;
	if (IsWindowVisible()==TRUE)visible=0;
	MainWinAppPtr->WriteProfileInt(section,"visible",visible);
	MainWinAppPtr->WriteProfileInt(section,"showc" ,p.showCmd);
	MainWinAppPtr->WriteProfileInt(section,"prminx",p.ptMinPosition.x);
	MainWinAppPtr->WriteProfileInt(section,"prminy",p.ptMinPosition.y);
	MainWinAppPtr->WriteProfileInt(section,"prmaxx",p.ptMaxPosition.x);
	MainWinAppPtr->WriteProfileInt(section,"prmaxx",p.ptMaxPosition.y);
	MainWinAppPtr->WriteProfileInt(section,"nposx1",p.rcNormalPosition.left);
	MainWinAppPtr->WriteProfileInt(section,"nposy1",p.rcNormalPosition.top);
	MainWinAppPtr->WriteProfileInt(section,"nposx2",p.rcNormalPosition.bottom);
	MainWinAppPtr->WriteProfileInt(section,"nposy2",p.rcNormalPosition.right);
}

// ---------------------------------------------------------------

void CDialogTool::LoadWindowPosition(const char *id,bool noresize)
{
	if (!DialogNoLoadSize)
	{
		WINDOWPLACEMENT p;
		WINDOWPLACEMENT i;GetWindowPlacement(&i);
		String section;section.Format("WinPos%s",id);
		p.flags=WPF_SETMINPOSITION;
		short visible;
		visible=MainWinAppPtr->GetProfileInt(section,"visible" ,0);
		p.showCmd        =MainWinAppPtr->GetProfileInt(section,"showc" ,SW_SHOWNORMAL);
		p.ptMinPosition.x=MainWinAppPtr->GetProfileInt(section,"prminx",0);
		p.ptMinPosition.y=MainWinAppPtr->GetProfileInt(section,"prminy",0);
		p.ptMaxPosition.x=MainWinAppPtr->GetProfileInt(section,"prmaxx",0);
		p.ptMaxPosition.y=MainWinAppPtr->GetProfileInt(section,"prmaxx",0);
		p.rcNormalPosition.left  =MainWinAppPtr->GetProfileInt(section,"nposx1",i.rcNormalPosition.left);
		p.rcNormalPosition.top   =MainWinAppPtr->GetProfileInt(section,"nposy1",i.rcNormalPosition.top);
		p.rcNormalPosition.bottom=MainWinAppPtr->GetProfileInt(section,"nposx2",i.rcNormalPosition.bottom);
		p.rcNormalPosition.right =MainWinAppPtr->GetProfileInt(section,"nposy2",i.rcNormalPosition.right);
		if (noresize==true)
		{
			p.rcNormalPosition.bottom=p.rcNormalPosition.top+(i.rcNormalPosition.bottom-i.rcNormalPosition.top);
			p.rcNormalPosition.right=p.rcNormalPosition.left+(i.rcNormalPosition.right-i.rcNormalPosition.left);
		}

		SetWindowPlacement(&p);
		//if (visible==1)ShowWindow(SW_HIDE);
		//else ShowWindow(SW_SHOW);
	}
}

// ---------------------------------------------------------------
// Custom, one stacked timer system.

void CDialogTool::ExecuteTimers(long ID)
{
	if (ID==-1)
	{
		_TimerList *c=(_TimerList *)TimerList.next;
		while (c!=NULL)
		{
			((CDialogTool *)c->window)->TimerCall(c->ID);
			c=(_TimerList *)c->next;
		}
	}
	else
	{
		_TimerList *c=(_TimerList *)TimerList.next;
		while (c!=NULL)
		{
			if (c->ID==ID)
				((CDialogTool *)c->window)->TimerCall(c->ID);
			c=(_TimerList *)c->next;
		}
	}
}

// ---------------------------------------------------------------

void CDialogTool::AddToTimer(long ID)
{
	_TimerList *c=new _TimerList(&TimerList);
	c->window=this;
	c->ID=ID;
}

// ---------------------------------------------------------------

void CDialogTool::RemoveFromTimer(long ID)
{
	redo:;
	_TimerList *c=(_TimerList *)TimerList.next;
	while (c!=NULL)
	{
		if (c->window==this)
		{
			if (ID==-1 || c->ID==ID){delete c;goto redo;}
		}
		c=(_TimerList *)c->next;
	}
}

// ---------------------------------------------------------------

void CDialogTool::TimerCall(UINT nIDEvent)
{

}

// ---------------------------------------------------------------

void CDialogTool::GetControlRect(CWnd *control,CRect *rect,short x1,short y1,short x2,short y2)
{
	control->GetWindowRect(rect);
	ScreenToClient(rect);

	if (x1==x2 && x2==y1 && y1==y2 && x1==-1);
	else
	{
		rect->DeflateRect(x1,y1,x2,y2);
	}
}

// ---------------------------------------------------------------

void CDialogTool::MultilineToListbox(CListBox *l,String *t)
{
	long i=0;
	String d;
	while (i!=-1)
	{
		i=t->GetLine(0,&d,i);
		if (i!=-1)l->AddString(d);
	}
}

// ---------------------------------------------------------------

void CDialogTool::UpdateDialogTitle(String &title)
{
	dialogtitle=title;
	dialogtitle.SetWnd(this);
//	if (dmanager!=NULL)((DialogManager *)dmanager)->UpdateCall(this);
}

// ---------------------------------------------------------------

void CDialogTool::CallMsgList(long MsgID,long msg,long dta1,long dta2)
{
	List<MessageElement>::Iter  iter=MessageList.Begin();
	while (iter.IsValid())
	{
		iter->window->message_handler(msg,dta1,dta2);
		iter++;
	}	
}

// ---------------------------------------------------------------

void CDialogTool::AddToMsgList(long MsgID)
{
	List<MessageElement>::Iter  iter=MessageList.Add();
	iter->window=this;
	iter->msgID=MsgID;
}

// ---------------------------------------------------------------

void CDialogTool::RemoveFromMsgList()
{
	List<MessageElement>::Iter iter=MessageList.Begin();
	while (iter.IsValid())
	{
		if(iter->window==this)
		{
			MessageList.Remove(iter);
			iter=MessageList.Begin();
		}
		else iter++;
	}
}

// ---------------------------------------------------------------

