/*
---------------------------------------------------------------------------
|		 			  Dialog helper functions
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:

TODO .. Use CString for the string things..

Changes:
*/
// Maximum amount of move objects
#ifndef _H_DIALOGTOOL
#define _H_DIALOGTOOL


//---------------------------------------------------------------------------
// forward definition
class DialogManager;

//---------------------------------------------------------------------------
// information on how you want this dialog to be created and sized

// messaging defines
enum
{
	// window modes
	DLWM_NONE,
	DLWM_THIN,
	DLWM_DIALOG,
	DLWM_SIZING,

	_DTMSG_CLOSE   = 1,	// close /hide it
	_DTMSG_MINIMIZE= 2,
	_DTMSG_MAXIMIZE= 3,
	_DTMSG_UPDATE  = 4,	// Standard UPDATE message.. so .. mostly redraw the thing
	_DTMSG_NOTIFY  = 5,	// Notify the window of something .. 
	_DTMSG_CUSTOM1 = 6,	// Custom message 1
	_DTMSG_CUSTOM2 = 7,	// Custom message 2
	_DTMSG_CUSTOM3 = 8,	// Custom message 3
	_DTMSG_CUSTOM4 = 9	// Custom message 4
};

//---------------------------------------------------------------------------

// internally used data
class  _SizeData:public _Cchain 
{
	public:
	_SizeData(_Cchain *i_prev=NULL):_Cchain(i_prev){};
	virtual ~_SizeData(){};

	CWnd	*control;
	CRect	rect;
	bool	init;
	CPoint	Origin[2];
};

//---------------------------------------------------------------------------

DECLARE_CLASS(CDialogTool);

class  CDialogTool : public CDialog
{
	public:
	CDialogTool(short IDD,CWnd* pParent = NULL);   // standard constructor
	virtual ~CDialogTool();   // standard constructor

	// saves the dialog's position to archive
	friend	rArchive operator<<(rArchive arc, rCDialogTool b); // starting point for serialization
	friend	rArchive operator>>(rArchive arc, rCDialogTool b);

	// does creation
	void CreateDlg(long ID,CWnd *pParent);
	void CloseDlg();

	// the main shutdown routine
	virtual void ShutdownDialog();

	// Edit control helper functions.. TODO.. make them better
	bool  UpdatingControl;
	float UpdatingValue;
	inline float IsUpdating(float val)	{if (UpdatingControl==true)return UpdatingValue;return(val);}
	float GetValue(CWnd *obj,float step=0,float min=0,bool limmin=false,float max=0,bool limmax=false);
	float GetValueLim(CWnd *obj,float step,float min,bool limmin,float max,bool limmax,short commas=3);
	void  SetValue(CWnd *obj,float val,short commas=3);
	void  SetValueLim(CWnd *obj,float val,float step,float min,bool limmin,float max,bool limmax,short commas=3);
	void  SetText(CWnd *obj,char *text);
	CWnd  *GetSetObject;
	
	// Check box helpers
	void SetBool(CButton *obj,bool state);
	bool GetBool(CButton *obj);

	// List box helper
	void MultilineToListbox(CListBox *l,String *t);

	// Move/size data
	void SizeControl(CWnd *obj,short x,short y,float xf1,float yf1,float xf2,float yf2,bool redraw=true);

	void SizeControlStart(); // sets window/control sizing on
	
	bool SizeMessagesActive;
	bool SizeMessagesStarting;
	// control data...
	_SizeData SizeData;
	//void	*dmanager; // pointer to dialog manager who controls this dialog
	void	*framedlg; // pointer to a possible frame dialog
	long	lastframe; // last frame
	String	dialogtitle;
	void	UpdateDialogTitle(String &title);

	// wrap data.. (Mouse Wrapping)
	long xwrap,ywrap; // wrap counters
	void MakeWrapped(CPoint *p);
	void ResetWrap();

	// window closing/showing/hiding stuff
	void TopWindow(); 
	void ShowWin();
	void HideWin();
	virtual bool ToggleWin(CWnd *win=NULL); //true is visible.. false is hidden
	bool windowisvisible;

	// Timer helper shit.. no more MyTimer crap...
	long InitTimerID; // if !=-1.. timer is active..
	bool OpenTimer(long timeout);
	void CloseTimer();

	// Utilities
	void GetControlRect(CWnd *control,CRect *rect,short x1=-1,short y1=-1,short x2=-1,short y2=-1);

	// Messaging thing:
	virtual long message_handler(long msg,long dta1=0,long dta2=0);

	// Saveing/loading of window positions from/to registry
	void SaveWindowPosition(const char *id);
	void LoadWindowPosition(const char *id,bool noresize=false);

	// Custom, one stacked timer system... fix for the normal timer
	static  void ExecuteTimers(long ID);
	virtual void AddToTimer(long ID);
	virtual void RemoveFromTimer(long ID=-1);
	virtual void TimerCall(UINT nIDEvent);

	// 'message' lists dialogs can post a requst

	static void CallMsgList(long MsgID,long msg,long dta1=0,long dta2=0);
	virtual void AddToMsgList(long MsgID);
	virtual void RemoveFromMsgList();


	static bool DialogNoLoadSize;

};

#endif