#ifndef _MEMDC_H_
#define _MEMDC_H_

class CMemDC : public CDC {
private:
	CBitmap		m_bitmap;	 // Offscreen bitmap
	CBitmap*	m_oldBitmap; // bitmap originally found in CMemDC
	CDC*		m_pDC;		 // Saves CDC passed in constructor
	CRect		m_rect;		 // Rectangle of drawing area.
	BOOL		m_bMemDC;	 // TRUE if CDC really is a Memory DC.
	bool flip;

public:

	CMemDC(CDC* pDC, const CRect& rcBounds) : CDC(), m_oldBitmap(NULL), m_pDC(pDC), m_rect(rcBounds) 
	{
		ASSERT(m_pDC != NULL); // If you asserted here, you passed in a NULL CDC.
		flip=true;
		// Create a Memory DC
		CreateCompatibleDC(pDC);
		//pDC->GetClipBox(&m_rect);
		m_bitmap.CreateCompatibleBitmap(pDC, m_rect.Width(), m_rect.Height());
		m_oldBitmap = SelectObject(&m_bitmap);
		SetWindowOrg(m_rect.left, m_rect.top);
	}
	
	~CMemDC()
	{
		if (flip==true)
		{
			// Copy the offscreen bitmap onto the screen.
			m_pDC->BitBlt(m_rect.left, m_rect.top, m_rect.Width(), m_rect.Height(),
				this, m_rect.left, m_rect.top, SRCCOPY);
			//Swap back the original bitmap.
			SelectObject(m_oldBitmap);
		}
	}

	void NoFlip(){flip=false;}	
	CMemDC* operator->() {return this;}
	operator CMemDC*() {return this;}
};

#endif
 