/*
---------------------------------------------------------------------------
|	Tree class, to be used as a a thing like _Cchain, but then in tree form
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#ifndef _H_CLASSTREE
#define _H_CLASSTREE
class  _ctree
{
	public:
		_ctree(_ctree *parent=NULL,bool inserttop=true);
		virtual ~_ctree();

		// dumb archive operators
		inline friend rArchive operator<<(rArchive arc, _ctree &v){return(arc);}
		inline friend rArchive operator>>(rArchive arc, _ctree &v){return(arc);}


		virtual void	place(_ctree *i_parent,bool inserttop=false);	// inserts into tree
		virtual void    remove();					// removes from tree
		virtual void	move(_ctree *i_parent,bool inserttop=false);	    // moves to other parent
		virtual void	movechildren(_ctree *i_parent); // children to other parent
		// NOTE .. SLIDE is malfunctioning!
		virtual void	slide(bool down);			// Slides up and down the tree, on this level
		virtual void    move_bottom();
		virtual void    move_top();
		_ctree		   *findlastsibling();			// finds last sibling..
		_ctree		   *enumchild(long num);
		long			getenumchild(_ctree *c);

		virtual _ctree	*copy(_ctree *i_parent);
		virtual void	copynb(_ctree *i_parent);

		virtual bool	IsChildOf(_ctree *object); // checks wether this object is a child of object

		virtual void	delete_children();

		_ctree *walk(_ctree *startobj=NULL,short *d=NULL,bool passbranch=false);	// walks the sequencer tree.. 

		_ctree *prev;
		_ctree *next;
		_ctree *parent;
		_ctree *child;
};

#endif