/*
---------------------------------------------------------------------------
|					Color defines and functions
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/ 

#include "Library.h"

//---------------------------------------------------------------------------

long  PF_TypeFromMask(long rm,long gm,long bm,long am)
{
	if (am==0) 
	{
		if (rm==0x00ff0000  && gm==0x0000ff00 && bm==0x000000ff)return PF_RGB_X888;
		if (rm==0x000000ff	&& gm==0x0000ff00 && bm==0x00ff0000)return PF_BGR_X888;
		if (rm==0xf800		&& gm==0x07e0	  && bm==0x001f	   )return PF_RGB_565;
		if (rm==0x7c00		&& gm==0x03e0	  && bm==0x001f	   )return PF_RGB_555;
		if (rm==0x001f		&& gm==0x03e0	  && bm==0x7c00	   )return PF_BGR_555;
	}
	else
	{
		if (am==0xff000000  && rm==0x00ff0000 && gm==0x0000ff00 && bm==0x000000ff )return PF_ARGB_8888;
		if (am==0x000000ff  && rm==0xff000000 && gm==0x00ff0000 && bm==0x0000ff00 )return PF_RGBA_8888;
		if (am==0x000000ff  && rm==0x0000ff00 && gm==0x00ff0000 && bm==0xff000000 )return PF_BGRA_8888;
		if (am==0x8000		&& rm==0x7c00	  && gm==0x03e0	    && bm==0x001f	  )return PF_ARGB_1555;
		if (am==0x0001		&& rm==0xf800	  && gm==0x07c0		&& bm==0x003e	  )return PF_RGBA_5551;
		if (am==0x0001		&& rm==0x003e	  && gm==0x07c0		&& bm==0xf800	  )return PF_BGRA_5551;
	}	if (am==0xf000		&& rm==0x0f00	  && gm==0x00f0		&& bm==0x000f	  )return PF_ARGB_4444;
	return(-1);
}

void  PF_MaskFromType(long type,long &rm,long &gm,long &bm,long &am)
{
	switch(type)
	{
		case PF_INDEX_8:	 am=0 		    ,rm=0			,gm=0			,bm=0;				break;
		case PF_ALPHA_8:	 am=0xff		,rm=0			,gm=0			,bm=0;				break;
		case PF_ARGB_8888:   am=0xff000000  ,rm=0x00ff0000  ,gm=0x0000ff00  ,bm=0x000000ff;  	break;
		case PF_RGBA_8888:   am=0x000000ff  ,rm=0xff000000  ,gm=0x00ff0000  ,bm=0x0000ff00;  	break;
		case PF_BGRA_8888:   am=0x000000ff  ,rm=0x0000ff00  ,gm=0x00ff0000  ,bm=0xff000000;  	break;
		case PF_ARGB_1555:   am=0x8000		,rm=0x7c00		,gm=0x03e0		,bm=0x001f;  		break;
		case PF_RGBA_5551:   am=0x0001		,rm=0xf800		,gm=0x07c0		,bm=0x003e;  		break;
		case PF_BGRA_5551:   am=0x0001		,rm=0x003e		,gm=0x07c0		,bm=0xf800;  		break;
		case PF_ARGB_4444:   am=0xf000		,rm=0xf000		,gm=0x0f00		,bm=0x000f;  		break;
		case PF_RGB_X888:	 am=0  			,rm=0x00ff0000	,gm=0x0000ff00  ,bm=0x000000ff;		break;
		case PF_BGR_X888:	 am=0  			,rm=0x000000ff	,gm=0x0000ff00  ,bm=0x00ff0000;		break;
		case PF_RGB_565:	 am=0 			,rm=0xf800		,gm=0x07e0		,bm=0x001f;			break;
		case PF_RGB_555:	 am=0 			,rm=0x7c00		,gm=0x03e0		,bm=0x001f;			break;	
		case PF_BGR_555:	 am=0 			,rm=0x001f		,gm=0x03e0		,bm=0x7c00;			break;
	};
};

//---------------------------------------------------------------------------

long  PF_Size(long type)
{ 
	switch(type)
	{
		case PF_INDEX_8:	 return(1);
		case PF_ALPHA_8:	 return(1);
		case PF_ARGB_8888:   return(4);
		case PF_RGBA_8888:   return(4);
		case PF_BGRA_8888:   return(4);
		case PF_ARGB_1555:   return(2);
		case PF_RGBA_5551:   return(2);
		case PF_BGRA_5551:   return(2);
		case PF_ARGB_4444:   return(2);
		case PF_RGB_X888:	 return(4);
		case PF_BGR_X888:	 return(4);
		case PF_RGB_565:	 return(2);
		case PF_RGB_555:	 return(2);
		case PF_BGR_555:	 return(2);
		default: return(0);
	}
}

//---------------------------------------------------------------------------

String			PF_ToString(long type)
{
	switch(type)
	{
		case PF_INDEX_8:	 return String("Indexed 8 Bit");
		case PF_ALPHA_8:	 return String("Alpha 8 Bit");
		case PF_ARGB_8888:   return String("ARGB 8888");
		case PF_RGBA_8888:   return String("RGBA 8888");
		case PF_BGRA_8888:   return String("BGRA 8888");
		case PF_ARGB_1555:   return String("ARGB 1555");
		case PF_RGBA_5551:   return String("RGBA 5551");
		case PF_BGRA_5551:   return String("BGRA 5551");
		case PF_ARGB_4444:   return String("ARGB 4444");
		case PF_RGB_X888:	 return String("RGB X888");
		case PF_BGR_X888:	 return String("BGR X888");
		case PF_RGB_565:	 return String("RGB 565");
		case PF_RGB_555:	 return String("RGB 555");
		case PF_BGR_555:	 return String("BGR 555");
		default: return String("Undeclared");
	}
}

//---------------------------------------------------------------------------

long  PF_BppOfType(long type)
{ 
	switch(type)
	{
		case PF_INDEX_8:	 return(8);
		case PF_ALPHA_8:	 return(8);
		case PF_ARGB_8888:   return(32);
		case PF_RGBA_8888:   return(32);
		case PF_BGRA_8888:   return(32);
		case PF_ARGB_1555:   return(16);
		case PF_RGBA_5551:   return(16);
		case PF_BGRA_5551:   return(16);
		case PF_ARGB_4444:   return(16);
		case PF_RGB_X888:	 return(32);
		case PF_BGR_X888:	 return(32);
		case PF_RGB_565:	 return(16);
		case PF_RGB_555:	 return(15);
		case PF_BGR_555:	 return(15);
		default: return(0);
	}
}

//---------------------------------------------------------------------------

long  PF_TypeOfBpp(long bpp)
{
	switch(bpp)
	{
		case 8:		return PF_INDEX_8;
		case 15:	return PF_RGB_555;
		case 16:	return PF_RGB_565;
		case 24:	return PF_RGB_X888;
		case 32:	return PF_ARGB_8888;
		default: return(0);
	}
}

//---------------------------------------------------------------------------
RGBColor  &RGBColor::FromType(long pf,dword d)
{
	switch(pf)
	{
		case PF_INDEX_8:	 
		case PF_ALPHA_8:	 return FromA8((byte)d);	 
		case PF_ARGB_8888:   return FromARGB_8888(d);
		case PF_RGBA_8888:   return FromRGBA_8888(d);
		case PF_BGRA_8888:   return FromBGRA_8888(d);
		case PF_ARGB_1555:   return FromARGB_1555((word)d);
		case PF_RGBA_5551:	 return FromRGBA_5551((word)d);
		case PF_BGRA_5551:   return FromBGRA_5551((word)d);
		case PF_ARGB_4444:   return FromARGB_4444((word)d);
		case PF_RGB_X888:	 return FromRGB_X888(d);
		case PF_BGR_X888:	 return FromBGR_X888(d);
		case PF_RGB_565:	 return FromRGB_565((word)d);
		case PF_RGB_555:	 return FromRGB_555((word)d);
		case PF_BGR_555:	 return FromBGR_555((word)d);
		default: return(*this);
	}
}

dword	  RGBColor::ToType(long pf)
{
	switch(pf)
	{
		case PF_INDEX_8:	 
		case PF_ALPHA_8:	 return ToA8();	 
		case PF_ARGB_8888:   return ToARGB_8888();
		case PF_RGBA_8888:   return ToRGBA_8888();
		case PF_BGRA_8888:   return ToBGRA_8888();
		case PF_ARGB_1555:   return ToARGB_1555();
		case PF_RGBA_5551:   return ToRGBA_5551();
		case PF_BGRA_5551:   return ToBGRA_5551();
		case PF_ARGB_4444:   return ToARGB_4444();
		case PF_RGB_X888:	 return ToRGB_X888();
		case PF_BGR_X888:	 return ToBGR_X888();
		case PF_RGB_565:	 return ToRGB_565();
		case PF_RGB_555:	 return ToRGB_555();
		case PF_BGR_555:	 return ToBGR_555();
		default: return(0);
	}
}
RGBIColor  &RGBIColor::FromType(long pf,dword d)
{
	switch(pf)
	{
		case PF_INDEX_8:	 
		case PF_ALPHA_8:	 return FromA8((byte)d);	 
		case PF_ARGB_8888:   return FromARGB_8888(d);
		case PF_RGBA_8888:   return FromRGBA_8888(d);
		case PF_BGRA_8888:   return FromBGRA_8888(d);
		case PF_ARGB_1555:   return FromARGB_1555((word)d);
		case PF_RGBA_5551:	 return FromRGBA_5551((word)d);
		case PF_BGRA_5551:   return FromBGRA_5551((word)d);
		case PF_ARGB_4444:   return FromARGB_4444((word)d);
		case PF_RGB_X888:	 return FromRGB_X888(d);
		case PF_BGR_X888:	 return FromBGR_X888(d);
		case PF_RGB_565:	 return FromRGB_565((word)d);
		case PF_RGB_555:	 return FromRGB_555((word)d);
		case PF_BGR_555:	 return FromBGR_555((word)d);
		default: return(*this);
	}
}

dword	  RGBIColor::ToType(long pf)
{
	switch(pf)
	{
		case PF_INDEX_8:	 
		case PF_ALPHA_8:	 return ToA8();	 
		case PF_ARGB_8888:   return ToARGB_8888();
		case PF_RGBA_8888:   return ToRGBA_8888();
		case PF_BGRA_8888:   return ToBGRA_8888();
		case PF_ARGB_1555:   return ToARGB_1555();
		case PF_RGBA_5551:   return ToRGBA_5551();
		case PF_BGRA_5551:   return ToBGRA_5551();
		case PF_ARGB_4444:   return ToARGB_4444();
		case PF_RGB_X888:	 return ToRGB_X888();
		case PF_BGR_X888:	 return ToBGR_X888();
		case PF_RGB_565:	 return ToRGB_565();
		case PF_RGB_555:	 return ToRGB_555();
		case PF_BGR_555:	 return ToBGR_555();
		default: return(0);
	}
}

// RGB/HSV conversion
RGBColor  RGBColor::HSV_to_RGB()
{
	 // H is given on [0, 6] or UNDEFINED. S and V are given on [0, 1].  
	 // RGB are each returned on [0, 1].  
	 float h = r, s = g, v = b, m, n, f;  
	 int i;  
  
	 //if(h == 0) return RGBColor(v, v, v);  
	 i = floor(h);  
	 f = h - i;  
	 if(!(i & 1)) f = 1 - f; // if i is even  
	 m = v * (1 - s);  
	 n = v * (1 - s * f);  
	 switch (i) 
	 {  
	  case 6:  
	  case 0: return RGBColor(v, n, m, a);  
	  case 1: return RGBColor(n, v, m, a);  
	  case 2: return RGBColor(m, v, n, a);
	  case 3: return RGBColor(m, n, v, a);  
	  case 4: return RGBColor(n, m, v, a);  
	  default:
	  case 5: return RGBColor(v, m, n, a);  
	}
	
}

//---------------------------------------------------------------------------

RGBColor RGBColor::RGB_to_HSV()
{
	 // RGB are each on [0, 1]. S and V are returned on [0, 1] and H is  
	 // returned on [0, 6]. Exception: H is returned UNDEFINED if S==0.  
	 float v, x, f;  
	 int i;  
  
	 x = fmin3(r, g, b);  
	 v = fmax3(r, g, b);  
	 if(v == x) return RGBColor(0,0,v);
	 f = (r == x) ? g - b : ((g == x) ? b - r : r - g);  
	 i = (r == x) ? 3 : ((g == x) ? 5 : 1);  
	 return RGBColor( (i - f /(v - x)), (v - x)/v, v, a);  
}

//---------------------------------------------------------------------------

RGBColor RGBColor::RGB_to_HWB() 
{
	 // RGB are each on [0, 1]. W and B are returned on [0, 1] and H is  
	 // returned on [0, 6]. Exception: H is returned UNDEFINED if W == 1 - B.  
	 float  w, v, x, f;  
	 long i;  
  
	 w = fmin3(r, g, b);  
	 v = fmax3(r, g, b);  
	 x = 1 - v;  
	 if  (v == w) return RGBColor(0,w,x);  
	 f = (r == w) ? g - b : ((g == w) ? b - r : r - g);  
	 i = (r == w) ? 3 : ((g == w) ? 5 : 1);  
	 return RGBColor(i - f /(v - w), w, x);  
}

//------------------------------------------------------------------------------

RGBColor RGBColor::HWB_to_RGB() 
{
	 // H is given on [0, 6] or UNDEFINED. W and B are given on [0, 1].  
	 // RGB are each returned on [0, 1].  
	 float h = r, w = g, v, n, f;  
	 int i;  
  
	 v = 1 - b;  
	 if (h == 0) return RGBColor(v, v, v);  
	 i = floor(h);  
	 f = h - i;  
	 if (i & 1) f = 1 - f; // if i is odd  
	 n = w + f * (v - w); // linear interpolation between w and v  
	 switch (i) 
	 {  
		case 6:  
		case 0: return RGBColor(v, n, w);  
		case 1: return RGBColor(n, v, w);  
		case 2: return RGBColor(w, v, n);  
		case 3: return RGBColor(w, n, v);  
		case 4: return RGBColor(n, w, v);  
		default:
		case 5: return RGBColor(v, w, n);  
	 }  
}


