/*
---------------------------------------------------------------------------
|					Color table palette (256 entries)
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

#include "Library.h"



// ---------------------------------------------------------------------------

void ColorTable::ToFloat()
{	
	for (long i=0;i<256;i++)col[i]/=255.0f;
};

// ---------------------------------------------------------------------------

void ColorTable::ToByte()
{	
	for (long i=0;i<256;i++)col[i]*=255.0f;
};
 
// ---------------------------------------------------------------------------

	// Initialization functions
void ColorTable::LinearRamp(RGBColor *start,RGBColor *end)
{
	for (long i=0;i<256;i++)
	{
		col[i]=start->Interpolate(*end,((float)i/255.0f));
	};
}

// ---------------------------------------------------------------------------

void ColorTable::LinearMultiramp(RGBColor *list,long len)
{
	// step size..
	long stepsize=256/len,start=0,i=0,j;
	for (j=0;j<len;j++)
	{
		for (;i<start+stepsize;i++)
		{
			if (i>255)i=255;
			col[i]=list[j].Interpolate(list[j+1],((float)(i-start)/(float)stepsize) );
		};
		start=i;
	}
}
