
/*
---------------------------------------------------------------------------
|					Color table, palette system
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#ifndef _H_COLORTABLE
#define _H_COLORTABLE

DECLARE_CLASS(ColorTable);

class  ColorTable	// pal
{
	public:
	ColorTable(){};
	~ColorTable(){};
	
	cColorTable operator=(cColorTable o)				{ for (long i=0;i<256;i++)col[i]=o.col[i],lst[i]=o.lst[i];lstlen=o.lstlen;return *this;} // archiving 

	void ToFloat(); // 0-1 mode.. standard
	void ToByte();  // 0-255 mode..

	// Initialization functions
	void LinearRamp(RGBColor *start,RGBColor *end);
	void LinearMultiramp(RGBColor *list,long len);

	RGBColor col[256];
	RGBColor lst[256]; //linear list of all colors used for the palette
	long	 lstlen;   //length of that list
	friend	rArchive operator<<(rArchive arc, cColorTable b){ for (long i=0;i<256;i++)arc<<b.col[i];return arc;} // archiving 
	friend	rArchive operator>>(rArchive arc, rColorTable b){ for (long i=0;i<256;i++)arc>>b.col[i];return arc;} // archiving 
};

#endif