/*
---------------------------------------------------------------------------
|		   Dialog manager, featuring other dialog framing and parenting
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

// layout modes
enum
{
	DML_FULL,
	DML_2HOR,
	DML_2VER,
	DML_3TOP,
	DML_4SQ,
	DML_4PSQ,
	DML_3SQ,
	DML_5SP
};

//---------------------------------------------------------------------------
// data of one of the DM frames


class  DMFrame
{
	public:
	CWnd				*object;	  // object owning frame
	CRect				 frame;       // frame coordinates
	long				 visible;	  // no of visible window
	PtrList<CDialogTool> windows;	  // which windows are in there
};

//---------------------------------------------------------------------------

class  DialogManager 
{
public:
	DialogManager();
	~DialogManager();

	// Element management
	void AddWindow(CDialogTool *window,long frameNo); // adds window to view (selected in dialog data)
	void RemoveWindow(CDialogTool *window);			  // removes window from list
	void SetLayout(long type);			 // sets standard layouts

	// query 
	CDialogTool *GetCurTop(long frame);
	
	// drawing
	void DrawSplitters(CDC &dc);
	void GetButRect(long num,CRect &t,CRect &f);

	// Mouse moving
	void GetMouse(CPoint &p,long &frame,long &value); 
	long OnMouseDown(CPoint &p);		 // Mouse drag modes
	void OnMouseUp(CPoint &p);			 // checks for mouseclicks
	void WindowDrop(CPoint &p,long srcframe,bool swap);	// dragged window was dropeed somewhere
	// external updating called, redraw the frame
	void UpdateCall(CDialogTool *src);

	// move a window from frame to frame
	void MoveWindow(CDialogTool *window,long targetframe);

	long FindWindow(CDialogTool *window,bool movetop=false);

	bool IsValidWindow(CDialogTool *window); // checks if its not the bottom window anywhere

	CWnd *parent;						 // what parent window
	long layout;						 // layout
	long nFrames;
	Array<DMFrame> Frames;                // first frame is always the 'global' frame
};

//---------------------------------------------------------------------------
