#include "Library.h"
#include "FileFunctions.h"
//--------------------------------------------------------------------------------


CFile curhandle;
bool	RdEr=false;
short	RdErType=0;

//--------------------------------------------------------------------------------

 bool FFOpenFile(char *filename)
{
RdEr=false;
if (curhandle.Open(filename,CFile::modeCreate|CFile::modeNoTruncate|CFile::modeReadWrite)!=0)return(true);
return(false);
}

//--------------------------------------------------------------------------------

 void FFCloseFile()
{
curhandle.Close();
RdEr=false;
}


//--------------------------------------------------------------------------------

 void WrID(short ID)
{
curhandle.Write(&ID,2);
}

//--------------------------------------------------------------------------------

 void WrC(short i,short ID)
{
	WrID(_FF_IDCHAR+(ID&0xff));
	curhandle.Write(&i,1);
}

//--------------------------------------------------------------------------------

 void WrS(short i,short ID)
{
	WrID(_FF_IDSHORT+(ID&0xff));
	curhandle.Write(&i,2);
}

//--------------------------------------------------------------------------------

 void WrB(bool i,short ID)
{
	char j;
	if (i==true)j=1;
	else j=0;
	WrID(_FF_IDBOOL+(ID&0xff));
	curhandle.Write(&j,1);
}

//--------------------------------------------------------------------------------
 void WrL(long i,short ID)
{
	WrID(_FF_IDLONG+(ID&0xff));
	curhandle.Write(&i,4);
}

//--------------------------------------------------------------------------------

 void WrF(float i,short ID)
{
	WrID(_FF_IDFLOAT+(ID&0xff));
	curhandle.Write(&i,4);
}

//--------------------------------------------------------------------------------

 void WrD(double i,short ID)
{
WrID(_FF_IDDOUBLE+(ID&0xff));
curhandle.Write(&i,8);
}

//--------------------------------------------------------------------------------

// String
 void WrT(char *text,short ID)
{
WrID(_FF_IDSTRING+(ID&0xff));
long len=0;
if (text!=NULL)len=strlen(text)+1;
WrL(len,0);
if (len!=0)curhandle.Write(text,len);
}


//--------------------------------------------------------------------------------

//Block
 void WrX(void *i,long len,short ID)
{
WrID(_FF_IDBLOCK+(ID&0xff));
if (i==NULL)len=0;
WrL(len,0);
if (len!=0)curhandle.Write(i,len);
}

//--------------------------------------------------------------------------------

 short RdID()
{
short i;
curhandle.Read(&i,2);
return(i);
}

//--------------------------------------------------------------------------------

 char RdC(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDCHAR)if (RdEr==false){RdEr=true,RdErType=0x0100+(ID&0xff);return(0);};
char i;
curhandle.Read(&i,1);
return(i);
}



//--------------------------------------------------------------------------------

 short RdS(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDSHORT)if (RdEr==false){RdEr=true,RdErType=0x0200+(ID&0xff);return(0);};
short i;
curhandle.Read(&i,2);
return(i);
}

//--------------------------------------------------------------------------------

 bool RdB(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDBOOL)if (RdEr==false){RdEr=true,RdErType=0x0300+(ID&0xff);return(false);};
char i;
curhandle.Read(&i,1);
if (i==1)return(true);
return(false);
}

//--------------------------------------------------------------------------------

 long RdL(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDLONG)if (RdEr==false){RdEr=true,RdErType=0x0400+(ID&0xff);return(0);};
long i;
curhandle.Read(&i,4);
return(i);
}

//--------------------------------------------------------------------------------

 float RdF(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDFLOAT)if (RdEr==false){RdEr=true,RdErType=0x0500+(ID&0xff);return(0);};
float i;
curhandle.Read(&i,4);
return(i);
}

//--------------------------------------------------------------------------------

 double RdD(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDDOUBLE)if (RdEr==false){RdEr=true,RdErType=0x0600+(ID&0xff);return(0);};
double i;
curhandle.Read(&i,8);
return(i);
}

//--------------------------------------------------------------------------------

 char *RdT(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDSTRING)if (RdEr==false){RdEr=true,RdErType=0x0700+(ID&0xff);return(NULL);};
long len=RdL();
if (len==0)return(NULL);
char *r=new char[len];
curhandle.Read(r,len);
return(r);
}


//--------------------------------------------------------------------------------

 void *RdX(short ID)
{
if (ID==-1)ID=RdID();
if ((ID&0xff00)!=_FF_IDBLOCK)if (RdEr==false){RdEr=true,RdErType=0x0800+(ID&0xff);return(NULL);};
long len=RdL();
if (len==0)return(NULL);
char *r=new char[len];
curhandle.Read(r,len);
return(r);
}

//--------------------------------------------------------------------------------

 void RdU(short ID)
{
if (ID==-1)ID=RdID();
char *r;long len;
switch(ID&0xff00)
{
	case  _FF_IDCHAR:
		len=1;
		break;
	case _FF_IDSHORT:	
		len=2;
		break;
	case _FF_IDLONG:
		len=4;
		break;
	case _FF_IDBOOL:
		len=1;
		break;
	case _FF_IDFLOAT:
		len=4;
		break;
	case _FF_IDDOUBLE:
		len=8;
		break;
	case _FF_IDSTRING:
		len=RdL();
		break;
	case _FF_IDBLOCK:
		len=RdL();
		break;
	default:
		if (RdEr==false){RdEr=true,RdErType=0x0100+(ID&0xff);goto pass;};
		break;
}
if (len>0)
{
	r=new char[len];
	curhandle.Read(r,len);
	delete r;
}
pass:;
}