/*
---------------------------------------------------------------------------
|Simple file functions. Allows to simply write your data objects to a file
|			Without the risk of making it a complete chaos.
|	Works with only 1 file open at a time. All read/write actions are taken
|	Into that file. Thus making a filehandle not needed, and by that creating
|	A lot less code. (no pointer passing from function to function etc..)
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:

Changes:
	Monday 6th july:	Initial file setup
*/
#pragma once

// Define your filetags here:
// Defining filetags locally is ok for plugins, but as
// it becomes part of the system, define it here so the file can be
// mapped out afterwards (looked into) without knowing exactly what the data is.

// These defines are obsolete
//	#define _FF_CTIMETABLE	0x1800
//	#define _FF_KEYLIST		0x1900
//	#define _FF_CCLIP		0x1a00
//	#define _FF_CSOUND		0x1b00
//	#define _FF_CFX			0x1c00

// Rest of the header
// DO NOT define below here .


// Basic file element id's
#define _FF_IDEMPTY		0x0000
#define _FF_IDCHAR		0x0100
#define _FF_IDSHORT		0x0200
#define _FF_IDLONG		0x0300
#define _FF_IDBOOL		0x0400
#define _FF_IDFLOAT		0x0500
#define _FF_IDDOUBLE	0x0600
#define _FF_IDSTRING	0x0700
#define _FF_IDBLOCK		0x0800

// Other ID's used for in-file tags
#define	_FF_ENDOFFILE	0x0900	//end of file
#define	_FF_ENDOFTREE	0x1000	//end of tree data

#define _FF_CHILD		0x1100	//Child data folowing immediately
#define	_FF_PARENT		0x1200	//Going back to parent

#define _FF_DEFAULTEND	0x1300	//Default end-of-block id

#define _FF_BT_TREE		0x1400	//Tree data block following
// obsoleted
//#define _FF_BT_KEYS		0x1500	//Activation key block following


// The file version, change this when mayor changes make it impossible to
// read older files
#define MAINFILEVERSION 200

extern  bool FFOpenFile(char *filename);

// Dunno
extern  void FFCloseFile();


// Local ID's can be used by the code in a loop, so future additions don't mess up
// the file.. and it can read older versions. Newer ones also, but only if you use
// the default: RdU() system..

extern  void WrID(short ID=0);			// Write 16 bits of id data (NO CHECK!) to the file
extern  void WrC(short i,short ID=0);	// Write 8 bits char + 8 bits local ID + 8bit block identifier
extern  void WrS(short i,short ID=0);	// Write 16 bits short + 8 bits local ID + 8bit block identifier
extern  void WrL(long i,short ID=0);		// Write 32 bits long + 8 bits local ID + 8bit block identifier
extern  void WrB(bool i,short ID=0);		// Write 8 bits (bool)char + 8 bits local ID + 8bit block identifier
extern  void WrF(float i,short ID=0);	// Write 32 bits float + 8 bits local ID + 8bit block identifier
extern  void WrD(double i,short ID=0);	// Write 64 bits double + 8 bits local ID + 8bit block identifier
extern  void WrT(char *text,short ID=0); // Write n chars (until NULL) + 8 bits local ID + 8bit block identifier
extern  void WrX(void *i,long len,short ID=0); // Write len chars  + 8 bits local ID + 8bit block identifier


// For meaning of symbols look above, if the ID!=-1, means that no ID should be read and
// The one passed should be used (usefull in load loops)
extern  short	RdID();
extern  char		RdC(short ID=-1);
extern  short	RdS(short ID=-1);
extern  bool		RdB(short ID=-1);
extern  long		RdL(short ID=-1);
extern  float	RdF(short ID=-1);
extern  double	RdD(short ID=-1);
extern  char		*RdT(short ID=-1);
extern  void		*RdX(short ID=-1);
extern  void		RdU(short ID=-1); // UNKNOWN read method.. just skips unknown data (datatypes defined above..)
extern  bool		RdEr;
extern  short	RdErType;

#define RdEC() {if (RdEr==true){char temp[100];sprintf(temp,"Error in reading blocks (%x), press Cancel for ASSERT failure",RdErType);if (AfxMessageBox(temp,MB_OKCANCEL)==IDCANCEL)ASSERT(1<0);RdEr=false;}}

