/*
---------------------------------------------------------------------------
|			Compiling function tree things to raw assembler
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

#ifndef _H_FUNCASM
#define _H_FUNCASM
#include "AsmObj.h"

//----------------------------------------------------------------------------------------
typedef void ( *CalcPtrType)();

DECLARE_CLASS(FuncAsm);
class  FuncAsm:public FuncTree
{
	public:
	FuncAsm();
	FuncAsm(String &eq);
	virtual ~FuncAsm();

	rFuncAsm operator=(rFuncAsm    other)					{ other.Copy(this); return *this; }
	rFuncAsm operator=(rString     other)					{ Create(other);return *this; }

	virtual FuncTreeNode *CreateSubnode(FuncTreeNode *parent=NULL);

	virtual bool Create(String &func,long cookie=-1);

	virtual void Copy(FuncTree *target,long cookie=-1); // copys equation without reparsing the string somewhere else

	// temporary data used in assembler
	word td_controlword;
	// temporary data
	dword  td_powhold;
	dword  td_signhold;
	dword  td_longholder;

	double final;					// final output
	bool Compile();					// compiles the functree into asm
	CalcPtrType CalcPtr;			// pointer to function
	AsmObj d;

	static bool HighPrec;
	virtual double Calculate(char var1,double val1)							{SetVariable(var1,val1);return(Calculate());}
	virtual double Calculate(char var1,double val1,char var2,double val2)	{SetVariable(var1,val1);SetVariable(var2,val2);return(Calculate());}
	virtual double Calculate();		// calcs outcome
};

//----------------------------------------------------------------------------------------

class  FuncAsmNode:public FuncTreeNode
{
	public:
	FuncAsmNode(FuncTree *base,_ctree *parent=NULL):FuncTreeNode(base,parent)
	{
	};
	virtual ~FuncAsmNode(){};
	double a,b,v;					  // variable holders

	bool CompileNode(AsmObj &d,double *optr);  // adds code to the fdata array
};

#endif