/*
---------------------------------------------------------------------------
|						GDI Image Implementation (HBitmap)
|		Base class implements 'generic' storage (new/delete buffer)
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

#ifndef _H_IMAGEGDI
#define _H_IMAGEGDI

class  ImageGDI :public Image
{
	public:

		ImageGDI();
		virtual ~ImageGDI();
		
		virtual long GetType(){return 2;} // returns derived class type

		// data storage functions
		virtual bool SetSize(ImageDesc &iid);
		virtual void SetPalette(ColorTable &p);  // updates palette
				
		// causes memory inside image to be released,and image invalidated
		virtual void ReleaseBuffer(bool lock=true);

		// windows specific functions
		void DrawGDI(void *tdc/*CDC **/,void *trect/*CRect **/,bool scale=true);
		// windows specific functions
		void DrawGDI(CDC &dc,CRect &rect,bool scale=true,bool flipv=false);
			
		void *hBitmap;	  //handle
		void *BitmapInfo; // bm info structure
};

#endif