/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "vfcalcglobals.h"
#include "GridResolve.h"
void CalcMode_eq::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd; 

	SolveFunctree s;
	s.func=&func.fa;
	s.col=col.point;
	s.dc=dd.dc;
	s.ftow_xscale	=dd.ftow_xscale;
	s.ftow_xoffset	=dd.ftow_xoffset;
	s.ftow_yscale	=dd.ftow_yscale;
	s.ftow_yoffset	=dd.ftow_yoffset;

	switch(var.SubType)
	{
		case 0:	s.maxdepth=8;s.startlevel=3; break;
		case 1: s.maxdepth=9;s.startlevel=4; break;	
		case 2: s.maxdepth=10;s.startlevel=5;break;
	}

	s.RefineDraw2D(_INIT_CALL,dd.f_start,dd.f_max,dd.f_end,dd.f_min,0);
}

//--------------------------------------------------------------------

void CalcMode_eq::SetControls()
{
	CVfcalcDlg::variables &var =vc->var;	
	vc->m_ViewSubType.ResetContent();
	show(&vc->m_DomT1);				show(&vc->m_DomT2);				show(&vc->m_SldD1);			show(&vc->m_SldD2);
	show(&vc->m_DomT4);				show(&vc->m_DomT3);				show(&vc->m_SldD3);			show(&vc->m_SldD4);
	txt(&vc->m_FPreTypeA,"fz(xy)=");hide(&vc->m_FPreTypeB);hide(&vc->m_FPreTypeC);
	txt(&vc->m_DomainTitle,"");
	show(&vc->m_FuncCA);			hide(&vc->m_FuncCB);		hide(&vc->m_FuncCC);
	show(&vc->m_AddA);				hide(&vc->m_AddB);			hide(&vc->m_AddC);
	show(&vc->m_FOPreTypeA);	hide(&vc->m_FOPreTypeB);hide(&vc->m_FOPreTypeC);	show(&vc->m_FOPx);		show(&vc->m_FOPy);
	hide(&vc->m_Derive_A);		hide(&vc->m_Derive_B);	hide(&vc->m_Derive_C);
	hide(&vc->m_Length_A);		hide(&vc->m_Length_B);	hide(&vc->m_Length_C);
	hide(&vc->m_Derive2_A);		hide(&vc->m_Derive2_B);	hide(&vc->m_Derive2_C);
	hide(&vc->m_Normal_A);			hide(&vc->m_Normal_B);			hide(&vc->m_Normal_C);
	hide(&vc->m_Int_A);			hide(&vc->m_Int_B);		hide(&vc->m_Int_C);
	show(&vc->m_ViewX);			show(&vc->m_ViewY);		show(&vc->m_ViewA);			hide(&vc->m_ViewB);		hide(&vc->m_ViewC);
	txt(&vc->m_FOPreTypeA,"Eq");
	txt(&vc->m_FixParamX,"");
	vc->m_ViewSubType.AddString(_T_EQ_ST0);
	vc->m_ViewSubType.AddString(_T_EQ_ST1);
	vc->m_ViewSubType.AddString(_T_EQ_ST2);
	var.SubType=0;
	vc->m_ViewSubType.SetCurSel(var.SubType);
}

//--------------------------------------------------------------------

void CalcMode_eq::ShowNumbers(double x,double y)
{
	String t,d;
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	t.FormatSpec(x,NDIGITS,var.outputmode,var.acc).SetWnd(&vc->m_ViewX);
	t.FormatSpec(y,NDIGITS,var.outputmode,var.acc).SetWnd(&vc->m_ViewY);
	func.fa.SetVariable('x',x);	func.fa.SetVariable('y',y);
	t.FormatSpec(func.fa.Calculate(),NDIGITS,var.outputmode,var.acc).SetWnd(&vc->m_ViewA);
}
