/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "vfcalcglobals.h" 

void CalcMode_fx::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd;
	
	double	x,y,u,v,w,ov,ow;
	double	step=((dd.w_end-dd.w_start)*var.stepsize)/dd.ftow_xscale;
	long	ptcount;

	FuncTree *ft;	
	bool nor,der,intg,der2,len;

	for (short i=0;i<3;i++)
	{
		if (i==0){ft=&func.fa,nor=sw.nor_a,der=sw.der_a,intg=sw.int_a;der2=sw.der2_a;len=sw.len_a;dd.dc->SelectObject(&dd.p_line1);}	
		if (i==1){ft=&func.fb,nor=sw.nor_b,der=sw.der_b,intg=sw.int_b;der2=sw.der2_b;len=sw.len_b;dd.dc->SelectObject(&dd.p_line2);}	
		if (i==2){ft=&func.fc,nor=sw.nor_c,der=sw.der_c,intg=sw.int_c;der2=sw.der2_c;len=sw.len_c;dd.dc->SelectObject(&dd.p_line3);}
		if (nor==true)
		{
			// Draw the normal f(x)
			long points=(long)((dd.f_end-dd.f_start)/step)+10;
			CPoint *pointlst=new CPoint[points];ptcount=0;

			for (u=dd.f_start;u<dd.f_end;u+=step)
			{
				if (step<1e-200)break;
				v=ft->Calculate('x',u,'t',u);
				x=(dd.ftow_xscale*u+dd.ftow_xoffset);y=(dd.ftow_yscale*v+dd.ftow_yoffset);
				if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;
				if (ptcount>=points-1)break; // whoops ? array overflow?
				pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
			}
			dd.dc->Polyline(pointlst,ptcount);
			delete pointlst;
		}
		if (der==true)
		{
			// Draw the normal f'(x)
			long points=(long)((dd.f_end-dd.f_start)/step)+10;
			CPoint *pointlst=new CPoint[points];ptcount=0;
			for (u=dd.f_start;u<dd.f_end;u+=step)
			{
				if (step<1e-200)break;
				x=(dd.ftow_xscale*u+dd.ftow_xoffset);
				v=ft->Calculate('x',u,'t',u);
				if (u==dd.f_start)
				{
					ov=v;
				}
				else
				{
					y=(dd.ftow_yscale*((v-ov)/step)+dd.ftow_yoffset);
					if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;ov=v;
					if (ptcount>=points-1)break; // whoops ? array overflow?
					pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
				}
			}
			dd.dc->Polyline(pointlst,ptcount);
			delete pointlst;
		}
		if (der2==true)
		{
			// Draw the f"(x)
			long points=(long)((dd.f_end-dd.f_start)/step)+10;
			CPoint *pointlst=new CPoint[points];ptcount=0;
			for (u=dd.f_start;u<dd.f_end;u+=step)
			{
				if (step<1e-200)break;	
				x=(dd.ftow_xscale*u+dd.ftow_xoffset);
				v=ft->Calculate('x',u,'t',u);
				if (u<=dd.f_start+step)
					ow=((v-ov)/step);
				else
				{
					w=((v-ov)/step);
					y=(dd.ftow_yscale*((w-ow)/step)+dd.ftow_yoffset);
					if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;
					if (ptcount>=points-1)break; // whoops ? array overflow?
					pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
					ow=w;
				}
				ov=v;					
			}
			dd.dc->MoveTo(pointlst[0].x,pointlst[0].y);
			dd.dc->Polyline(pointlst,ptcount);
			delete pointlst;
		}
		if (len==true)
		{
			// Draw the length from var.dt1 to var.dt2
			double step2=(var.dt2-var.dt1)*var.stepsize;
			ov=0;ow=0;
			long points=(long)((var.dt2-var.dt1)/step2)+10;
			CPoint *pointlst=new CPoint[points];ptcount=0;
			
			for (u=var.dt1;u<var.dt2;u+=step2)
			{
				if (step<1e-200)break;				
				v=ft->Calculate('x',u,'t',u);
				if (u==var.dt1)
				{
					ov=v;
				}
				else
				{
					ow+=sqrt((v-ov)*(v-ov)+step2*step2);
					x=(dd.ftow_xscale*u+dd.ftow_xoffset);y=(dd.ftow_yscale*ow+dd.ftow_yoffset);
					if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;
					if (ptcount>=points-1)break; // whoops ? array overflow?
					pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
					ov=v;
				}
			}
			dd.dc->Polyline(pointlst,ptcount);
			delete pointlst;
		}
		if (intg==true)
		{
			// Draw the integral from var.dt1 to var.dt2
			double step2=(var.dt2-var.dt1)*var.stepsize;
			ov=0;
			long points=(long)((var.dt2-var.dt1)/step2)+10;
			CPoint *pointlst=new CPoint[points];ptcount=0;
			for (u=var.dt1;u<var.dt2;u+=step2)
			{
				if (step<1e-200)break;
				v=ft->Calculate('t',u,'x',u);
				ov+=v*step2;
				x=(dd.ftow_xscale*u+dd.ftow_xoffset);y=(dd.ftow_yscale*ov+dd.ftow_yoffset);
				if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;
				if (ptcount>=points)break; // whoops ? array overflow?
				pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
			}
			dd.dc->Polyline(pointlst,ptcount);
			delete pointlst;
		}
	}
}

//-----------------------------------------------------------------------------

void CalcMode_fx::SetControls()
{
		vc->m_ViewSubType.ResetContent();
		show(&vc->m_DomT1);				show(&vc->m_DomT2);				show(&vc->m_SldD1);			show(&vc->m_SldD2);
		hide(&vc->m_DomT4);				hide(&vc->m_DomT3);				hide(&vc->m_SldD3);			hide(&vc->m_SldD4);
		txt(&vc->m_FPreTypeA,"f(x)=");txt(&vc->m_FPreTypeB,"g(x)=");txt(&vc->m_FPreTypeC,"h(x)=");
		txt(&vc->m_DomainTitle,_T_FX_DT);
		show(&vc->m_FPreTypeA);		show(&vc->m_FPreTypeB);	show(&vc->m_FPreTypeC);
		show(&vc->m_FuncCA);			show(&vc->m_FuncCB);		show(&vc->m_FuncCC);
		show(&vc->m_AddA);				show(&vc->m_AddB);			show(&vc->m_AddC);
		show(&vc->m_FOPreTypeA);	show(&vc->m_FOPreTypeB);show(&vc->m_FOPreTypeC);		show(&vc->m_FOPx);		show(&vc->m_FOPy);
		show(&vc->m_Derive_A);		show(&vc->m_Derive_B);	show(&vc->m_Derive_C);
		show(&vc->m_Int_A);			show(&vc->m_Int_B);		show(&vc->m_Int_C);
		show(&vc->m_Normal_A);		show(&vc->m_Normal_B);	show(&vc->m_Normal_C);
		show(&vc->m_Length_A);		show(&vc->m_Length_B);	show(&vc->m_Length_C);
		show(&vc->m_Derive2_A);		show(&vc->m_Derive2_B);	show(&vc->m_Derive2_C);
		
		show(&vc->m_ViewX);			show(&vc->m_ViewY);		show(&vc->m_ViewA);			show(&vc->m_ViewB);		show(&vc->m_ViewC);
		txt(&vc->m_FOPreTypeA,"f=");txt(&vc->m_FOPreTypeB,"g=");txt(&vc->m_FOPreTypeC,"h=");txt(&vc->m_FOPx,"x=");txt(&vc->m_FOPy,"y=");
		txt(&vc->m_FixParamX,"x:");
}

//-----------------------------------------------------------------------------

void CalcMode_fx::ShowNumbers(double x,double y)
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd;


	String t;
	t.FormatSpec(x,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewX);
	t.FormatSpec(y,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewY);
	
	FuncTree *ft;	CWnd *view;

	bool nor,der,der2,len,intg;char *type="\0";
	double u,v;

	for (short i=0;i<3;i++)
	{
		if (i==0){ft=&func.fa,nor=sw.nor_a,der=sw.der_a,intg=sw.int_a;der2=sw.der2_a;len=sw.len_a;view=&vc->m_ViewA;}	
		if (i==1){ft=&func.fb,nor=sw.nor_b,der=sw.der_b,intg=sw.int_b;der2=sw.der2_b;len=sw.len_b;view=&vc->m_ViewB;}	
		if (i==2){ft=&func.fc,nor=sw.nor_c,der=sw.der_c,intg=sw.int_c;der2=sw.der2_c;len=sw.len_c;view=&vc->m_ViewC;}
		if (der==true)
		{
			y=ft->Calculate('x',x);type="(-1)\0";
			v=(ft->Calculate('x',x+0.00000001)-y)/0.00000001;
		}else
		if (intg==true)
		{
			if (x>var.dt1 && x<=var.dt2)
			{
				double step2=(x-var.dt1)*var.stepsize,ov=0;
				for (u=var.dt1;u<x;u+=step2)
				{
					v=ft->Calculate('x',u);ov+=v*step2;
				}
				v=ov;
			}
			else v=0;
			type="(1)\0";
		}else
		if (der2==true)
		{
			double r,u,w;
			r=ft->Calculate('x',x);
			u=ft->Calculate('x',x+0.000001);
			w=ft->Calculate('x',x+0.000002);
			v=( ((w-u)/0.000001) - ((u-r)/0.000001) )/0.000001;
			type="(-2)\0";
		}else 
		if (len==true)
		{
			// Calc the length from var.dt1 to x
			if (x>var.dt1 && x<=var.dt2)
			{
				double step2=(var.dt2-var.dt1)*var.stepsize,ov=0,ow=0;
				for (u=var.dt1;u<=x;u+=step2)
				{
					v=ft->Calculate('x',u);
					if (u==var.dt1)
					{
						ov=v;
					}
					else
					{
						ow+=sqrt((v-ov)*(v-ov)+step2*step2);
						ov=v;
					}
				}
				v=ow;
			}
			else v=0;

			type="(L)\0";
		}else
		if (nor==true)
		{
			v=ft->Calculate('x',x);type="(0)\0";
		}
		if (intg==true || der==true || nor==true || len==true || der2==true)
		{
			char prefix[100];
			if (i==0){sprintf(prefix,"f%s=",type);vc->m_FOPreTypeA.SetWindowText(prefix);}
			if (i==1){sprintf(prefix,"g%s=",type);vc->m_FOPreTypeB.SetWindowText(prefix);}
			if (i==2){sprintf(prefix,"h%s=",type);vc->m_FOPreTypeC.SetWindowText(prefix);}
			t.FormatSpec(v,NDIGITS,var.outputmode,var.acc);t.SetWnd(view);
		}
		else view->SetWindowText("");
	}
}
