/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "vfcalcglobals.h" 

void CalcMode_ft3d::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd;
	
	float x,y,u;
	double step;
	long offset=0,ptcount=0;
	
	step=(var.dt2-var.dt1)*var.stepsize;

	CPoint *pointlst=new CPoint[(long)(1/var.stepsize)+100];
	Vector3 *vec=new Vector3[(long)(1/var.stepsize)+100];
	long amountofpoints=(long)(1/var.stepsize);

	// setup camera matrix
 
	Vector3 translate(0,0,var.viewdistance),out,in;
	Matrix4x4 m;m.SetRT(&var.viewrotate,&translate);

	float AspectX=768,AspectY=768;
	float  ScreenYCentre=(float)((dd.DrawFrame.bottom-dd.DrawFrame.top)/2+dd.DrawFrame.top),
	  	   ScreenXCentre=(float)((dd.DrawFrame.right-dd.DrawFrame.left)/2+dd.DrawFrame.left),tx,ty;
	float Clip_MaxX=(float)dd.DrawFrame.right+1000,
		  Clip_MinX=(float)dd.DrawFrame.left-1000,
		  Clip_MaxY=(float)dd.DrawFrame.bottom+1000,
		  Clip_MinY=(float)dd.DrawFrame.top-1000;

	dd.dc->FillRect(dd.DrawFrame,&dd.b_back);
	// 66
	if (var.gridfac!=0)
	{
		
		double bstep;
		if (var.gridfac>50)
			bstep=1.0/(50+0.0001);
		else bstep=1/(var.gridfac+0.0001); // 0.0001 takes away the grid fuck up
		long gsteps=(long)(1/bstep)+1,st,vt;
		double gstep=(var.dt4-var.dt3)*bstep;
		dd.dc->SelectObject(&dd.t_texts);	
		// for the bottom 
		CPoint *points=new CPoint[gsteps*gsteps+100];
		//if ((long)((var.dt4-var.dt3)/gstep)>gsteps)gsteps+=1;
		// first go draw the base grid
		for (x=(float)var.dt3,offset=0;x<=var.dt4;x+=(float)gstep)
		{
			for(y=(float)var.dt3;y<=var.dt4;y+=(float)gstep)
			{	
				in.Set(x,y,0);out=m*in;
				if (out.z<=0.1)out.z=0.1f;
				tx=clamp_f((out.x*AspectX/out.z)+ScreenXCentre,Clip_MinX,Clip_MaxX);
				ty=clamp_f((out.y*AspectY/out.z)+ScreenYCentre,Clip_MinY,Clip_MaxY);
				points[offset].y=ty;
				points[offset].x=tx;

				if (!sw.ShowNum)
				{
					String a; a.FormatSpec(x,3,var.outputmode,var.acc);
					String b; b.FormatSpec(y,3,var.outputmode,var.acc);
					String s;s.Format("(%s,%s)",(char *)a,(char *)b);
					dd.dc->TextOut(tx,ty,s,s.SLength());
				}

				offset++;		
			}
		}

		dd.dc->SelectObject(&dd.p_grid);	
		//// Now draw vertical lines
		CPoint *points2=new CPoint[gsteps];
		for (st=0;st<gsteps;st++)
			dd.dc->Polyline(&points[st*gsteps],gsteps);
		// Now draw Horizontal lines..
		for (st=0;st<gsteps;st++)
		{
			for (vt=0;vt<gsteps;vt++)
			{
				points2[vt]=points[vt*gsteps+st];
			}
			dd.dc->Polyline(points2,gsteps);
		}
		delete points;
		delete points2;
	}


	for (u=var.dt1,offset=0;u<=var.dt2;u+=step)
	{
		in.x=(float)vc->clipf(func.fa.Calculate('x',u,'t',u))*(float)var.fscale;
		in.y=(float)vc->clipf(func.fb.Calculate('x',u,'t',u))*(float)var.fscale;
		in.z=(float)vc->clipf(func.fc.Calculate('x',u,'t',u))*(float)var.fscale;
		
		// rotate and project
		out=m*in;
		if (out.z<=0.1)out.z=0.1f;
		tx=clamp_f((out.x*AspectX/out.z)+ScreenXCentre,Clip_MinX,Clip_MaxX);
		ty=clamp_f((out.y*AspectY/out.z)+ScreenYCentre,Clip_MinY,Clip_MaxY);
		vec[offset].Set(tx,ty,out.z);
	
		offset++;

	}
	// line calculated.. now go transform
	// Now go transform and draw the bastard..

	switch(var.SubType)
	{
		case 0:
		{
			for (long i=0;i<offset;i++)	pointlst[i].x=vec[i].x,	pointlst[i].y=vec[i].y;
			dd.dc->SelectObject(&dd.p_line1);	
			dd.dc->Polyline(pointlst,offset);
		}break;
		case 1:
		{
			for (long i=0;i<offset;i++)
			{
				dd.dc->SetPixelV((long)vec[i].x,(long)vec[i].y,col.point);
			}
		}break;
		case 2:
		{
			for (long i=0;i<offset;i++)
			{
				long x=(long)vec[i].x,y=(long)vec[i].y;
				dd.dc->SetPixelV(x  ,y  ,col.point);
				dd.dc->SetPixelV(x+1,y  ,col.point);dd.dc->SetPixelV(x  ,y-1,col.point);
				dd.dc->SetPixelV(x-1,y  ,col.point);dd.dc->SetPixelV(x  ,y+1,col.point);
			}
		}break;
		case 3:
		{
			for (long i=0;i<offset;i++)
			{
				short val=(short)clamp_s((short)255-vec[i].z*20,(short)0,(short)255);
				COLORREF col=RGB(val,val,val);
				dd.dc->SetPixelV((long)vec[i].x,(long)vec[i].y,col);
			}
		}break;
		case 4:
		{
			for (long i=0;i<offset;i++)
			{
				short val=(short)clamp_s((short)255-vec[i].z*20,(short)0,(short)255);
				COLORREF col=RGB(val,val,val);
				long x=(long)vec[i].x,y=(long)vec[i].y;
				dd.dc->SetPixelV(x  ,y  ,col);
				dd.dc->SetPixelV(x+1,y  ,col);dd.dc->SetPixelV(x  ,y-1,col);
				dd.dc->SetPixelV(x-1,y  ,col);dd.dc->SetPixelV(x  ,y+1,col);
			}
		}
		break;
		case 5:
		{
			short r,g,b;double rr,gg,bb;
			
			u=var.dt1;
			for (long i=0;i<offset;i++)
			{
				rr=func.fk.Calculate('x',u,'t',u);
				gg=func.fl.Calculate('x',u,'t',u);
				bb=func.fm.Calculate('x',u,'t',u);
				r=(short)clamp_s((short)(rr*255),(short)0,(short)255);
				g=(short)clamp_s((short)(gg*255),(short)0,(short)255);
				b=(short)clamp_s((short)(bb*255),(short)0,(short)255);
				COLORREF col1=RGB(r,g,b), col2=RGB(r>>1,g>>1,b>>1);
				long x=(long)vec[i].x,y=(long)vec[i].y;
				dd.dc->SetPixelV(x  ,y  ,col1);
				dd.dc->SetPixelV(x+1,y  ,col2);dd.dc->SetPixelV(x  ,y-1,col2);
				dd.dc->SetPixelV(x-1,y  ,col2);dd.dc->SetPixelV(x  ,y+1,col2);
				u+=step;
			}
		}
	}
	delete pointlst;
	delete vec;
}

//---------------------------------------------------------------------------

void CalcMode_ft3d::SetControls()
{
	CVfcalcDlg::variables &var =vc->var;	
	
	vc->m_ViewSubType.ResetContent();
	var.SubType=0;
	vc->m_ViewSubType.AddString(_T_FT3D_ST0);
	vc->m_ViewSubType.AddString(_T_FT3D_ST1);
	vc->m_ViewSubType.AddString(_T_FT3D_ST2);
	vc->m_ViewSubType.AddString(_T_FT3D_ST3);
	vc->m_ViewSubType.AddString(_T_FT3D_ST4);
	vc->m_ViewSubType.AddString(_T_FT3D_ST5);
	vc->m_ViewSubType.SetCurSel(var.SubType);
	txt(&vc->m_DomainTitle,_T_FT3D_DT);
	show(&vc->m_DomT1);				show(&vc->m_DomT2);				show(&vc->m_SldD1);				show(&vc->m_SldD2);
	show(&vc->m_DomT4);				show(&vc->m_DomT3);				show(&vc->m_SldD3);				show(&vc->m_SldD4);
	txt(&vc->m_FPreTypeA,"x(t)=");	txt(&vc->m_FPreTypeB,"y(t)=");	txt(&vc->m_FPreTypeC,"z(t)=");
	show(&vc->m_FPreTypeA);			show(&vc->m_FPreTypeB);			show(&vc->m_FPreTypeC);
	show(&vc->m_FuncCA);			show(&vc->m_FuncCB);			show(&vc->m_FuncCC);
	show(&vc->m_AddA);				show(&vc->m_AddB);				show(&vc->m_AddC);
	hide(&vc->m_Derive_A);			hide(&vc->m_Derive_B);			hide(&vc->m_Derive_C);
	hide(&vc->m_Int_A);				hide(&vc->m_Int_B);				hide(&vc->m_Int_C);
	hide(&vc->m_Normal_A);			hide(&vc->m_Normal_B);			hide(&vc->m_Normal_C);
	hide(&vc->m_Length_A);			hide(&vc->m_Length_B);			hide(&vc->m_Length_C);
	hide(&vc->m_Derive2_A);			hide(&vc->m_Derive2_B);			hide(&vc->m_Derive2_C);

	show(&vc->m_ViewX);				show(&vc->m_ViewY);				show(&vc->m_ViewA);				show(&vc->m_ViewB);		show(&vc->m_ViewC);
	show(&vc->m_FOPreTypeA);		show(&vc->m_FOPreTypeB);		show(&vc->m_FOPreTypeC);		show(&vc->m_FOPx);		show(&vc->m_FOPy);
	txt(&vc->m_FOPreTypeA,"x(t)=");	txt(&vc->m_FOPreTypeB,"y(t)=");	txt(&vc->m_FOPreTypeC,"z(t)=");	txt(&vc->m_FOPx,"x=");	txt(&vc->m_FOPy,"y=");
	txt(&vc->m_FixParamX,"t:");
}
//---------------------------------------------------------------------------
void CalcMode_ft3d::ShowNumbers(double x,double y)
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var=vc->var;

	func.fa.SetVariable('x',var.parx);	func.fb.SetVariable('x',var.parx);	func.fc.SetVariable('x',var.parx);
	func.fa.SetVariable('t',var.parx);	func.fb.SetVariable('t',var.parx);	func.fc.SetVariable('t',var.parx);

	String t;
	t.FormatSpec(func.fa.Calculate(),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewA);
	t.FormatSpec(func.fb.Calculate(),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewB);
	t.FormatSpec(func.fc.Calculate(),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewC);
}

