/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
 #include "Library.h"
#include "vfcalcglobals.h"
 
void CalcMode_calc::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col; 
	CVfcalcDlg::DrawData  &dd  =vc->dd;
 
	//output calculator data in window..
	CSize cs;
    
	func.fa.SetVariable('x',var.parx);	func.fb.SetVariable('x',var.parx);	func.fc.SetVariable('x',var.parx);
	func.fa.SetVariable('t',var.parx);	func.fb.SetVariable('t',var.parx);	func.fc.SetVariable('t',var.parx);
	func.fa.SetVariable('y',var.pary);	func.fb.SetVariable('y',var.pary);	func.fc.SetVariable('y',var.pary);

	dd.dc->FillRect(dd.DrawFrame,&dd.b_back);
 
	String t,d; 
	double z=func.fa.Calculate();
	t.Format("f() = %s",d.FormatSpec(z,15,var.outputmode,var.acc));
	cs=dd.dc->GetTextExtent(t,t.SLength());
	dd.dc->TextOut(dd.DrawFrame.left+(dd.DrawFrame.right-dd.DrawFrame.left)/2-cs.cx/2,
			   dd.DrawFrame.top+(dd.DrawFrame.bottom-dd.DrawFrame.top)/2-cs.cy,
			   t,t.SLength());

	t.Format("f() = %s",d.FormatSpec(func.fb.Calculate(),15,var.outputmode,var.acc));
	cs=dd.dc->GetTextExtent(t,t.SLength());
	dd.dc->TextOut(dd.DrawFrame.left+(dd.DrawFrame.right-dd.DrawFrame.left)/2-cs.cx/2,
			   dd.DrawFrame.top+(dd.DrawFrame.bottom-dd.DrawFrame.top)/2,
			   t,t.SLength());

	t.Format("f() = %s",d.FormatSpec(func.fc.Calculate(),15,var.outputmode,var.acc));
	cs=dd.dc->GetTextExtent(t,t.SLength());
	dd.dc->TextOut(dd.DrawFrame.left+(dd.DrawFrame.right-dd.DrawFrame.left)/2-cs.cx/2,
			   dd.DrawFrame.top+(dd.DrawFrame.bottom-dd.DrawFrame.top)/2+cs.cy,
			   t,t.SLength());
	ShowNumbers(0,0);
}

//--------------------------------------------------------------------------------------------

void CalcMode_calc::SetControls()
{
	vc->m_ViewSubType.ResetContent();
	show(&vc->m_DomT1);				show(&vc->m_DomT2);				show(&vc->m_SldD1);			show(&vc->m_SldD2);
	hide(&vc->m_DomT4);				hide(&vc->m_DomT3);				hide(&vc->m_SldD3);			hide(&vc->m_SldD4);
	show(&vc->m_FPreTypeA);			show(&vc->m_FPreTypeB);			show(&vc->m_FPreTypeC);
	show(&vc->m_FuncCA);			show(&vc->m_FuncCB);			show(&vc->m_FuncCC);
	show(&vc->m_AddA);				show(&vc->m_AddB);				show(&vc->m_AddC);
	txt(&vc->m_FPreTypeA,"f()=");txt(&vc->m_FPreTypeB,"g()=");txt(&vc->m_FPreTypeC,"h()=");
	txt(&vc->m_DomainTitle,"");
	show(&vc->m_FOPreTypeA);		show(&vc->m_FOPreTypeB);		show(&vc->m_FOPreTypeC);	hide(&vc->m_FOPx);	hide(&vc->m_FOPy);
	hide(&vc->m_Derive_A);			hide(&vc->m_Derive_B);			hide(&vc->m_Derive_C);
	hide(&vc->m_Int_A);				hide(&vc->m_Int_B);				hide(&vc->m_Int_C);
	hide(&vc->m_Normal_A);			hide(&vc->m_Normal_B);			hide(&vc->m_Normal_C);
	hide(&vc->m_Length_A);			hide(&vc->m_Length_B);			hide(&vc->m_Length_C);
	hide(&vc->m_Derive2_A);			hide(&vc->m_Derive2_B);			hide(&vc->m_Derive2_C);

	hide(&vc->m_ViewX);				hide(&vc->m_ViewY);				show(&vc->m_ViewA);			show(&vc->m_ViewB);		show(&vc->m_ViewC);
	txt(&vc->m_FOPreTypeA,"f()=");txt(&vc->m_FOPreTypeB,"g()=");txt(&vc->m_FOPreTypeC,"h()=");
	txt(&vc->m_FixParamX,"x:");
}

//--------------------------------------------------------------------------------------------


void CalcMode_calc::ShowNumbers(double x,double y)
{
	String t,d;
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	d.Format("f() = %s",t.FormatSpec(func.fa.Calculate(),15,var.outputmode,var.acc)).SetWnd(&vc->m_ViewA);
	d.Format("f() = %s",t.FormatSpec(func.fb.Calculate(),15,var.outputmode,var.acc)).SetWnd(&vc->m_ViewB);
	d.Format("f() = %s",t.FormatSpec(func.fc.Calculate(),15,var.outputmode,var.acc)).SetWnd(&vc->m_ViewC);
}