/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "vfcalcglobals.h"

//----------------------------------------------------------------------------------------
void CalcMode_xyim::Initialize()
{
	//CRect t;vc->GetClientRect(t);view.Startup(vc,&t,false);
	//view.Startup(&vc->m_DrawFrame,&vc->dd.DrawFrame,false);

} 

//----------------------------------------------------------------------------------------

void CalcMode_xyim::Shutdown()
{
	//view.Shutdown();	
}

//----------------------------------------------------------------------------------------
void CalcMode_xyim::Resize()
{
	//CRect t;vc->GetClientRect(t);
	//view.Shutdown();	
	//view.Startup(&vc->m_DrawFrame,&vc->dd.DrawFrame,false);
	//view.Resize(&vc->dd.DrawFrame);
}

//----------------------------------------------------------------------------------------

void CalcMode_xyim::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd;

	long PLASMAX = (long)fix(floor(fabs(var.dt2)),8);
	long PLASMAY = (long)fix(floor(fabs(var.dt4)),8);

	if (PLASMAX<40)PLASMAX=40;if (PLASMAX>1024)PLASMAX=1024;
	if (PLASMAY<40)PLASMAY=40;if (PLASMAY>1024)PLASMAY=1024;

	long PLASMAMAX = PLASMAX*PLASMAY;
	double x,y,xstep=(dd.f_end-dd.f_start)/(double)PLASMAX,ystep=(dd.f_min-dd.f_max)/(double)PLASMAY;
	long offset=0,offset2=0;

	long pixelmode=PF_RGB_565;
	// 2d heightmap drawing..

	ImageDesc idd;
	idd.xs=PLASMAX,idd.ys=PLASMAY;
	idd.pixelformat=pixelmode;
	idd.flags=0;

	output.SetSize(idd);
	ColorTable pal;RGBColor p[16];
	

	word	   pallookup[256];
	dword	   pallookup32[256];

	switch(var.SubType)
	{
		case 0:	// wit
			p[0].Set(0  ,0  ,0);
			p[1].Set(1	,1	,1);
			pal.LinearMultiramp(p,1);
			break;
		case 1: // inverted
			p[0].Set(1  ,1  ,1);
			p[1].Set(0  ,0  ,0);
			pal.LinearMultiramp(p,1);
			break;
		case 2: // rood wit
			p[0].Set(0,0,0);
			p[1].Set(1,0,0);
			p[2].Set(1,1,1);
			pal.LinearMultiramp(p,2);
			break;
		case 3: // groen wit
			p[0].Set(0,0,0);
			p[1].Set(0,1,0);
			p[2].Set(1,1,1);
			pal.LinearMultiramp(p,2);
			break;
		case 4: // blauw wit
			p[0].Set(0,0,0);
			p[1].Set(0,0,1);
			p[2].Set(1,1,1);
			pal.LinearMultiramp(p,2);
			break;
		case 5:	// rood groen
			p[0].Set(0,0,0);
			p[1].Set(1,0,0);
			p[2].Set(1,1,0);
			pal.LinearMultiramp(p,2);
			break;
		case 6:	// blauw groen
			p[0].Set(0,0,0);
			p[1].Set(0,0,1);
			p[2].Set(0,1,1);
			pal.LinearMultiramp(p,2);
			break;
		case 7:	// groen rood
			p[0].Set(0,0,0);
			p[1].Set(0,1,0);
			p[2].Set(1,1,0);
			pal.LinearMultiramp(p,2);
			break;
		case 8:	// blauw rood
			p[0].Set(0,0,0);
			p[1].Set(0,0,1);
			p[2].Set(1,0,1);
			pal.LinearMultiramp(p,2);
			break;
		case 9:	// rood blauw
			p[0].Set(0,0,0);
			p[1].Set(1,0,0);
			p[2].Set(1,0,1);
			pal.LinearMultiramp(p,2);
			break;
		case 10:	// groen blauw
			p[0].Set(0,0,0);
			p[1].Set(0,1,0);
			p[2].Set(0,1,1);
			pal.LinearMultiramp(p,2);
			break;
	}
	// build palette
	if (pixelmode==PF_RGB_565)
		for (long i=0;i<256;i++)pallookup[i]=pal.col[i].ToRGB_565();
	else if (pixelmode==PF_RGB_555)
		for (long i=0;i<256;i++)pallookup[i]=pal.col[i].ToRGB_555();
	else if (pixelmode==PF_RGB_X888)
		for (long i=0;i<256;i++)pallookup32[i]=pal.col[i].ToRGB_X888();
	else if (pixelmode==PF_BGRA_8888)
		for (long i=0;i<256;i++)pallookup32[i]=pal.col[i].ToBGRA_8888();

	if (pixelmode==PF_RGB_565 || pixelmode==PF_RGB_555)
	{
		word *data=(word *)output.LockData();
		if (data==NULL){/*MsgBox("could not create surface");*/goto  error;}

		for(y=dd.f_min;y>dd.f_max;y-=ystep)
		{
			offset=offset2;
			func.fa.SetVariable('y',y);
			for(x=dd.f_start;x<dd.f_end;x+=xstep)
			{
				if (offset>=PLASMAMAX)goto pass2;
				data[offset]=pallookup[(dword)clamp_f(func.fa.Calculate('x',x)*255.0f,0.0f,255.0f)];
				offset++;
			} 
			offset2+=PLASMAX;
		}
		pass2:;
		output.UnlockData();
	}
	if (pixelmode==PF_RGB_X888 || pixelmode==PF_BGRA_8888)
	{
		dword *data=(dword *)output.LockData();
		if (data==NULL){/*MsgBox("could not create surface");*/goto  error;}

		for(y=dd.f_min;y>dd.f_max;y-=ystep)
		{
			offset=offset2;
			func.fa.SetVariable('y',y);
			for(x=dd.f_start;x<dd.f_end;x+=xstep)
			{
				if (offset>=PLASMAMAX)goto pass3;
				data[offset]=pallookup32[(dword)clamp_f(func.fa.Calculate('x',x)*255.0f,0.0f,255.0f)];
				offset++;
			} 
			offset2+=PLASMAX;
		}
		pass3:;
		output.UnlockData();
	}
	output.DrawGDI(*dd.odc,dd.DrawFrame,true);

	
	error:;
}

void CalcMode_xyim::SetControls()
{
	CVfcalcDlg::variables &var =vc->var;	

	vc->m_ViewSubType.ResetContent();
	var.SubType=0;
	vc->m_ViewSubType.AddString(_T_FXYIM_ST0);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST1);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST2);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST3);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST4);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST5);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST6);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST7);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST8);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST9);
	vc->m_ViewSubType.AddString(_T_FXYIM_ST10);

	txt(&vc->m_DomainTitle,_T_FXYIM_DT);
	vc->m_ViewSubType.SetCurSel(var.SubType);
	hide(&vc->m_DomT1);				show(&vc->m_DomT2);			hide(&vc->m_SldD1);			show(&vc->m_SldD2);
	show(&vc->m_DomT4);				hide(&vc->m_DomT3);			hide(&vc->m_SldD3);			show(&vc->m_SldD4);
	txt(&vc->m_FPreTypeA,"A()=");txt(&vc->m_FPreTypeB,"B()=");	txt(&vc->m_FPreTypeC,"C()=");
	txt(&vc->m_DomainTitle,"Image Size(x)");
	show(&vc->m_FPreTypeA);			show(&vc->m_FPreTypeB);		show(&vc->m_FPreTypeC);
	show(&vc->m_FuncCA);			show(&vc->m_FuncCB);		show(&vc->m_FuncCC);
	show(&vc->m_AddA);				show(&vc->m_AddB);			show(&vc->m_AddC);
	show(&vc->m_FOPreTypeA);		show(&vc->m_FOPreTypeB);	show(&vc->m_FOPreTypeC);	show(&vc->m_FOPx);			show(&vc->m_FOPy);
	hide(&vc->m_Derive_A);			hide(&vc->m_Derive_B);		hide(&vc->m_Derive_C);
	hide(&vc->m_Int_A);				hide(&vc->m_Int_B);			hide(&vc->m_Int_C);
	hide(&vc->m_Normal_A);			hide(&vc->m_Normal_B);		hide(&vc->m_Normal_C);
	hide(&vc->m_Length_A);			hide(&vc->m_Length_B);		hide(&vc->m_Length_C);
	hide(&vc->m_Derive2_A);			hide(&vc->m_Derive2_B);		hide(&vc->m_Derive2_C);
	show(&vc->m_ViewX);				show(&vc->m_ViewY);			show(&vc->m_ViewA);			show(&vc->m_ViewB);			show(&vc->m_ViewC);
	txt(&vc->m_FOPreTypeA,"A=");	txt(&vc->m_FOPreTypeB,"B=");txt(&vc->m_FOPreTypeC,"C=");txt(&vc->m_FOPx,"x=");		txt(&vc->m_FOPy,"y=");
	txt(&vc->m_FixParamX,"x:");
}


void CalcMode_xyim::ShowNumbers(double x,double y)
{
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::functions &func=vc->func;

	String t;
	t.FormatSpec(x,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewX);
	t.FormatSpec(y,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewY);
	t.FormatSpec(func.fa.Calculate('x',x,'y',y),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewA);
	t.FormatSpec(func.fb.Calculate('x',x,'y',y),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewB);
	t.FormatSpec(func.fc.Calculate('x',x,'y',y),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewC);
}
