/*
---------------------------------------------------------------------------
|					Function drawing mode for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "vfcalcglobals.h"

CVfcalcDlg *wo; 

//------------------------------------------------------------------------------------------------

 
//------------------------------------------------------------------------------------------------


void CALLBACK waveOutProc( HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2 )
{
	if (uMsg==WOM_DONE && wo->snd.active==true && (wo->var.dt2-wo->var.dt1>wo->snd.buftime))
	{	// flip buffers and load
		char *swap=wo->snd.bufplay;wo->snd.bufplay=wo->snd.bufback;wo->snd.bufback=swap;
		WAVEHDR *wswap=wo->snd.WaveHdr;wo->snd.WaveHdr=wo->snd.WaveHdrSwap;wo->snd.WaveHdrSwap=wswap;
		// Now fill the buffer with new calculation. 
		
		double t,step=wo->snd.buftime/(double)wo->snd.buflen,
			    start=wo->snd.time,
				  end=wo->snd.time+wo->snd.buftime,u,v,delta;
		long offset=0;
		
		lock(wo->FuncLock);

		double scale8b=127.0,scale16b=32767.0;
		// split the buffers
		// time check stuff
		double starttime=GetTime(),endtime=wo->snd.buftime/1.2;
		long timecheck=0,checkstep=32;

		if (wo->snd.wf.nChannels==1)
		{
			if (wo->snd.wf.wBitsPerSample==16)
			{
				short *soundbuf=(short *)wo->snd.bufback;
				
				t = start;
				for(int i = 0;i<wo->snd.buflen;i++)
				{
					t+=step;
					v=wo->func.fa.Calculate('x',t,'t',t)*wo->var.fscale;
					if (v>1.0)v=1.0;if (v<-1.0)v=-1.0;v=v*scale16b;soundbuf[offset++]=(short)v;
				}
				wo->snd.time=t;
			}
			else // 8bit mono.
			{
				t = start;
				for(int i = 0;i<wo->snd.buflen;i++)
				{
					t+=step;
					v=wo->func.fa.Calculate('x',t,'t',t)*wo->var.fscale;
					if (v>1.0)v=1.0;if (v<-1.0)v=-1.0;v=v*scale8b+128.0;wo->snd.bufback[offset++]=(char)v;
				}
				wo->snd.time=t;
			}
		}
		else	// stereo
		{
			if (wo->snd.wf.wBitsPerSample==16)
			{
				t = start;
				for(int i = 0;i<wo->snd.buflen;i++)
				{
					t+=step;
					v=wo->func.fa.Calculate('x',t,'t',t)*wo->var.fscale;
					u=wo->func.fb.Calculate('x',t,'t',t)*wo->var.fscale;
					if (v>1.0)v=1.0;if (v<-1.0)v=-1.0;v*=scale16b;if (u>1.0)v=1.0;if (u<-1.0)u=-1.0;u*=scale16b;
					((unsigned long *)wo->snd.bufback)[offset++]=((((long)v)<<16)&0xffff0000)+((long)u&0xffff);
				}
				wo->snd.time=t;
			}
			else // 8bit stereo
			{
				t = start;
				for(int i = 0;i<wo->snd.buflen;i++)
				{
					t+=step;
					v=wo->func.fa.Calculate('x',t,'t',t)*wo->var.fscale;
					u=wo->func.fb.Calculate('x',t,'t',t)*wo->var.fscale;
					if (v>1.0)v=1.0;if (v<-1.0)v=-1.0;v=v*scale8b+128;if (u>1.0)v=1.0;if (u<-1.0)u=-1.0;u=u*scale8b+128;
					((short *)wo->snd.bufback)[offset++]=(((short)v)<<8)+(short)u;
				}
				wo->snd.time=t;
			}
		}
		bailout:;
		unlock(wo->FuncLock);


		waveOutWrite(wo->snd.hWaveOut, wo->snd.WaveHdr, sizeof(WAVEHDR));		

	}
}

//------------------------------------------------------------------------------------------------

void CVfcalcDlg::OpenSound()
{
	if (snd.active==true)CloseSound();
	
	snd.wf.wFormatTag=WAVE_FORMAT_PCM;
	switch (var.SubType)
	{
		case 0:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=44100;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=4; break;
		case 1:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=22050;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=4; break;
		case 2:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=11025;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=4; break;
		case 3:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=44100;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=2; break;
		case 4:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=22050;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=2; break;
		case 5:  snd.wf.nChannels=2;snd.wf.nSamplesPerSec=11025;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=2; break;
		case 6:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=44100;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=2; break;
		case 7:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=22050;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=2; break;
		case 8:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=11025;snd.wf.wBitsPerSample=16;snd.wf.nBlockAlign=2; break;
		case 9:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=44100;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=1; break;
		case 10:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=22050;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=1; break;
		case 11:  snd.wf.nChannels=1;snd.wf.nSamplesPerSec=11025;snd.wf.wBitsPerSample=8; snd.wf.nBlockAlign=1; break;
	}
	snd.wf.nAvgBytesPerSec=snd.wf.nSamplesPerSec*snd.wf.nBlockAlign;
	snd.wf.cbSize=sizeof(WAVEFORMATEX);
	if (waveOutOpen((LPHWAVEOUT)&snd.hWaveOut, WAVE_MAPPER, 
	                   &snd.wf, (LONG)waveOutProc, 0L, CALLBACK_FUNCTION)==MMSYSERR_NOERROR) 
	{
		wo=this;
		snd.buflen=4096;
		snd.buftime = (double)snd.buflen/(double)snd.wf.nSamplesPerSec;
		snd.time = 0;
		snd.bufsize=snd.buflen*snd.wf.nBlockAlign;
		snd.bufback=new char[2*snd.bufsize],
		snd.bufplay=new char[2*snd.bufsize];
		snd.updating=false;
		// Clear sound buffers.
		for (long i=0;i<snd.bufsize;i++)snd.bufback[i]=0,snd.bufplay[i]=0;

		snd.WaveHdr1.lpData=snd.bufplay;snd.WaveHdr1.dwBufferLength=snd.bufsize;snd.WaveHdr1.dwFlags=0;	snd.WaveHdr1.dwLoops=0;
		snd.WaveHdr2.lpData=snd.bufback;snd.WaveHdr2.dwBufferLength=snd.bufsize;snd.WaveHdr2.dwFlags=0;	snd.WaveHdr2.dwLoops=0;
		waveOutPrepareHeader(snd.hWaveOut, &snd.WaveHdr1, sizeof(WAVEHDR)); 
		waveOutPrepareHeader(snd.hWaveOut, &snd.WaveHdr2, sizeof(WAVEHDR)); 
		snd.WaveHdr=&snd.WaveHdr2;
		snd.WaveHdrSwap=&snd.WaveHdr1;
		waveOutWrite(snd.hWaveOut, &snd.WaveHdr1, sizeof(WAVEHDR));		
		waveOutWrite(snd.hWaveOut, &snd.WaveHdr2, sizeof(WAVEHDR));		
		snd.active=true;
		snd.time=0;
	}
	else snd.active=false;

}

//------------------------------------------------------------------------------------------------

void CVfcalcDlg::CloseSound()
{
	lock(FuncLock);
	if (snd.active==true)
	{
		snd.active=false;
		waveOutReset(snd.hWaveOut);
		waveOutUnprepareHeader(snd.hWaveOut, &snd.WaveHdr1, sizeof(WAVEHDR)); 
		waveOutUnprepareHeader(snd.hWaveOut, &snd.WaveHdr2, sizeof(WAVEHDR)); 
		waveOutClose(snd.hWaveOut);
		delete snd.bufback;
		delete snd.bufplay;
	}
	unlock(FuncLock);
}


//------------------------------------------------------------------------------------------------

void CalcMode_fts::Draw()
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var =vc->var;	
	CVfcalcDlg::switches  &sw  =vc->sw;
	CVfcalcDlg::colors	  &col =vc->col;
	CVfcalcDlg::DrawData  &dd  =vc->dd;
	
	double	x,y,u,v;
	double	step=((dd.w_end-dd.w_start)*var.stepsize)/dd.ftow_xscale;
	long	ptcount;

	FuncTree *ft;	
	for (short i=0;i<2;i++)
	{
		double start=dd.f_start,end=dd.f_end,vadd;

		if (i==0){ft=&func.fb;dd.dc->SelectObject(&dd.p_line1);vadd=0;}	
		if (i==1){ft=&func.fa;dd.dc->SelectObject(&dd.p_line2);vadd=2.5;}	

		// Draw the normal f(x)
		CPoint *pointlst=new CPoint[(long)((dd.f_end-dd.f_start)/step)+10];
		ptcount=0;

		if (dd.f_start<var.dt1)start=var.dt1;
		if (dd.f_end>var.dt2)end=var.dt2;

		for (u=start;u<end;u+=step)
		{
			v=ft->Calculate('x',u,'t',u)*var.fscale;
			if (v>1.0)v=1.0;if (v<-1.0)v=-1.0;v+=vadd;
			x=(dd.ftow_xscale*u+dd.ftow_xoffset);
			y=(dd.ftow_yscale*v+dd.ftow_yoffset);

			if (y<dd.w_min)y=dd.w_min-1;if (y>dd.w_max)y=dd.w_max+1;

			pointlst[ptcount].x=(long)x,pointlst[ptcount].y=(long)y;ptcount++;
		}
		dd.dc->Polyline(pointlst,ptcount);
		delete pointlst;
	}
}

//---------------------------------------------------------------------------

void CalcMode_fts::SetControls()
{
	CVfcalcDlg::variables &var =vc->var;	

	vc->m_ViewSubType.ResetContent();
	var.SubType=6;
	vc->m_ViewSubType.AddString("44Khz16b S");
	vc->m_ViewSubType.AddString("22Khz16b S");
	vc->m_ViewSubType.AddString("11Khz16b S");
	vc->m_ViewSubType.AddString("44Khz 8b S");
	vc->m_ViewSubType.AddString("22Khz 8b S");
	vc->m_ViewSubType.AddString("11Khz 8b S");
	vc->m_ViewSubType.AddString("44Khz16b M");
	vc->m_ViewSubType.AddString("22Khz16b M");
	vc->m_ViewSubType.AddString("11Khz16b M");
	vc->m_ViewSubType.AddString("44Khz 8b M");
	vc->m_ViewSubType.AddString("22Khz 8b M");
	vc->m_ViewSubType.AddString("11Khz 8b M");

	txt(&vc->m_DomainTitle,_T_FTS_DT);

	vc->m_ViewSubType.SetCurSel(var.SubType);
	show(&vc->m_DomT1);				show(&vc->m_DomT2);				show(&vc->m_SldD1);			show(&vc->m_SldD2);
	hide(&vc->m_DomT4);				hide(&vc->m_DomT3);				hide(&vc->m_SldD3);			hide(&vc->m_SldD4);
	txt(&vc->m_FPreTypeA,"l(t)=");	txt(&vc->m_FPreTypeB,"r(t)=");
	show(&vc->m_FPreTypeA);			show(&vc->m_FPreTypeB);			hide(&vc->m_FPreTypeC);
	show(&vc->m_FuncCA);			show(&vc->m_FuncCB);			hide(&vc->m_FuncCC);
	show(&vc->m_AddA);				show(&vc->m_AddB);				hide(&vc->m_AddC);
	hide(&vc->m_Derive_A);			hide(&vc->m_Derive_B);			hide(&vc->m_Derive_C);
	hide(&vc->m_Int_A);				hide(&vc->m_Int_B);				hide(&vc->m_Int_C);
	hide(&vc->m_Normal_A);			hide(&vc->m_Normal_B);			hide(&vc->m_Normal_C);
	hide(&vc->m_Length_A);			hide(&vc->m_Length_B);			hide(&vc->m_Length_C);
	hide(&vc->m_Derive2_A);			hide(&vc->m_Derive2_B);			hide(&vc->m_Derive2_C);

	show(&vc->m_ViewX);			show(&vc->m_ViewY);		show(&vc->m_ViewA);			show(&vc->m_ViewB);		hide(&vc->m_ViewC);
	show(&vc->m_FOPreTypeA);	show(&vc->m_FOPreTypeB);hide(&vc->m_FOPreTypeC);		show(&vc->m_FOPx);		show(&vc->m_FOPy);
	txt(&vc->m_FOPreTypeA,"l(t)=");txt(&vc->m_FOPreTypeB,"r(t)=");txt(&vc->m_FOPx,"t=");txt(&vc->m_FOPy,"y=");
	txt(&vc->m_FixParamX,"t:");
}

//---------------------------------------------------------------------------

void CalcMode_fts::ShowNumbers(double x,double y)
{
	CVfcalcDlg::functions &func=vc->func;
	CVfcalcDlg::variables &var=vc->var;

	String t;

	t.FormatSpec(x,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewX);
	t.FormatSpec(y,NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewY);

	func.fa.SetVariable('x',x);	func.fb.SetVariable('x',x);
	func.fa.SetVariable('t',x);	func.fb.SetVariable('t',x);


	t.FormatSpec(func.fa.Calculate(),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewA);
	t.FormatSpec(func.fb.Calculate(),NDIGITS,var.outputmode,var.acc);t.SetWnd(&vc->m_ViewB);
}

//---------------------------------------------------------------------------

void CalcMode_fts::Initialize()
{
	vc->CloseSound();vc->OpenSound();
}

//---------------------------------------------------------------------------

void CalcMode_fts::Shutdown()
{
	vc->CloseSound();
};
