/*
---------------------------------------------------------------------------
|					Function drawing modes for VFCalc
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/

//--------------------------------------------------------

class CalcMode_fx : public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_fx(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=true;};
		virtual ~CalcMode_fx(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};

//--------------------------------------------------------

class CalcMode_calc : public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_calc(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=false;};
		virtual ~CalcMode_calc(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};

//--------------------------------------------------------

class CalcMode_eq: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_eq(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=true;};
		virtual ~CalcMode_eq(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};

//--------------------------------------------------------

class CalcMode_ft: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_ft(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=true;};
		virtual ~CalcMode_ft(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};


//--------------------------------------------------------

class CalcMode_ft3d: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_ft3d(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=false;Has3DControl=true;};
		virtual ~CalcMode_ft3d(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};

 
//--------------------------------------------------------

class CalcMode_3dxy: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_3dxy(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=false;Has3DControl=true;HasSlideOnShift=true;};
		virtual ~CalcMode_3dxy(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};

//--------------------------------------------------------

class CalcMode_xyim: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_xyim(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=false;Has3DControl=false;HasNoBackBuffer=true;};
		virtual ~CalcMode_xyim(){};

		ImageGDI  output;

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();

		virtual void Initialize();
		virtual void Shutdown();
		virtual void Resize();
};

//--------------------------------------------------------

class CalcMode_fts: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_fts(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=true;Has3DControl=false;HasSoundReset=true;};
		virtual ~CalcMode_fts(){vc->CloseSound();};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();

		virtual void Initialize();
		virtual void Shutdown();

};

//--------------------------------------------------------

class CalcMode_3dfst: public CVfcalcDlg::CalcMode
{
		public:
		CalcMode_3dfst(CVfcalcDlg *o):CalcMode(o) {Has2DBackground=false;Has3DControl=true;HasSlideOnShift=false;};
		virtual ~CalcMode_3dfst(){};

		virtual void SetControls();
		virtual void ShowNumbers(double x,double y);
		virtual void Draw();
};
