/*
---------------------------------------------------------------------------
|						Multithread locking functions
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:
*/

#include "Library.h"

long num=0;

//---------------------------------------------------------------------------

MultithreadLock::MultithreadLock()
{
	deadlock=5;
	maxlock=2500;
	//fastlock=fast;
	//name=iname+String("_")+String(num++);
	handle=NULL;
	locked=false;
	//if (!fastlock)
	//{
		handle=CreateMutex(NULL,FALSE,NULL);
		if (handle==NULL)
		{
			//log("Error creating multithread object");
		}
	//}
};

//---------------------------------------------------------------------------

MultithreadLock::~MultithreadLock()
{
	if (handle!=NULL)
	{
		CloseHandle((HANDLE)handle);
		handle=NULL;
	}
};

//---------------------------------------------------------------------------
bool MultithreadLock::CheckLock()
{
	if (handle!=NULL)
	{
		abandoned:;
		long ret=WaitForSingleObject((HANDLE)handle,0);
		switch(ret)
		{
			case WAIT_ABANDONED:
				goto abandoned;
				break;
			case WAIT_OBJECT_0:
				// lock successfull
				locked=true;
				return(true);
			break;
			case WAIT_TIMEOUT: // timeout error
			return(false);
			break;
		};
	};
	if (fastlock)return locked;
	return(false);
}

//---------------------------------------------------------------------------

bool MultithreadLock::Lock(char *f,const int l)
{
	if (handle!=NULL)
	{
		abandoned:;
		long ret=WaitForSingleObject((HANDLE)handle,10000);
		switch(ret)
		{
			case WAIT_ABANDONED:
				goto abandoned;
				break;
			case WAIT_OBJECT_0:
				// lock successfull
				locked=true;
				return(true);
			break;
			case WAIT_TIMEOUT: // timeout error
				//log("Multithread Lock timeout: lock: %s file:%s line:%ld",(char *)name,f,l);		
				//assert(false);
				return(false);
				break;
		};
	};
	if (fastlock)
	{
		long lockingcount=0;
		bool d;
		while (lockingcount<maxlock)
		{
			volatile bool *b=&locked;
			_asm
			{
				mov eax,b
				bts [eax],0
				setb d
			}
			if (d==false)return(true);
			lockingcount++;
			Sleep(deadlock);
		}
		//log("Multithread Lock timeout: lock: %s file:%s line:%ld",(char *)name,f,l);		
		return(false);	
	}
	return(false);
}

//---------------------------------------------------------------------------

bool MultithreadLock::Unlock(char *f,const int l)
{
	if (handle!=NULL)
	{
		if (ReleaseMutex(handle)==FALSE)
		{
			//assert(false);
			//logfmt("Multithread Unlock failure: lock: %s file:%s line:%ld",(char *)name,f,l);		
			return(false);
		};
		locked=false;
		return(true);
	}
	else if (fastlock)
	{
		locked=false;
		return true;
	}	
	return(false);
}
	
//---------------------------------------------------------------------------
