/*
---------------------------------------------------------------------------
|	Popup menu encapsulation/simplification class
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#ifndef _H_POPUPMENU
#define _H_POPUPMENU

//---------------------------------------------------------------------------

enum
{
	POT_STRING	  =0,
	POT_BOOL	  =1,
	POT_SWITCH	  =2,
	POT_SUBTREE	  =4,
	POT_SEPARATOR =5
};

//---------------------------------------------------------------------------
#define MAXLTDEPTH 8

class  PopupTree : public _ctree	// Contains the popup tree
{
	public:
	PopupTree(_ctree *iparent=NULL,bool inserttop=true);

	void Set(String &treename,String &name,long type,void *data=NULL,long val=-1);

	// generic data
	String	 name; // this items name (full tree path-name);
	String   treename;
	long	 type;   // what type it is
	CMenu	*pmenu; // pointer to the menu this item is in

	// type specific data
	bool	*btarget; // if type is bool.. the target bool variable
	long	*ltarget; // if type is switch.. the target long
	bool    ValueChanged; // wether a switch or a bool has changed
	bool    MayChange;    // wether the thing in the pointer may be changed at all
	long	loffset;  // start of the switch
	CMenu	*smenu;   // if type is SUBTREE .. the CMenu of the subtree
	
	// init set data
	long	TreeVal; // which returnvalue this option got
	long	LevelTree[MAXLTDEPTH];
};

//---------------------------------------------------------------------------

class  PopupMenu
{
	public:	
	PopupMenu();
	~PopupMenu();

	void Clear(); // clears entire menu

	long Show(CWnd* pParent, CPoint *origin); // shows popup menu, return result
	
	PopupTree root;			 // the tree root
	PtrList<CMenu> menulist; // this list contains all CMenu objects
	
	long IDOffset;			// id counter

	String    GetNameTree(long val); // gets the menu tree string by return value
	PopupTree *GetNode(long val); // returns node by retval

	// id managment
	long IDTree[MAXLTDEPTH];
	void SetLevelID(long ID,long level=0);
	long GetType(long Val,long level=0);
	long GetType(PopupTree *t,long level=0);
	bool IsOfType(long Val,long ID,long level=0);
	bool IsOfType(PopupTree *t,long ID,long level=0);

	// item managment
	long AddString(const char *i,long ID=-1,bool IsTree=true,long level=0){return AddItem(i,NULL,false,false,IsTree,ID,level);}
	long AddBool(const char *i,bool &l,bool maychange=true,long ID=-1,long level=0){return AddItem(i,&l,false,maychange,true,ID,level);}
	long AddSeparator(const char *i=NULL){if (i==NULL)return AddItem(SubDir,NULL,true);return AddItem(i,NULL,true);}

	// internally used
	long AddItem(const char *i,void *boold=NULL,bool separator=false,bool valmaychange=true,bool IsTree=true,long ID=0,long level=-1);

	// switching managment
	void StartSwitch(long &l,bool maychange=true);	// indicates a switch start
	void StopSwitch();
	bool		IsSwitch;       // add menu is switch
	long	   *ltarget;		// the target long
	PopupTree  *switchnode;		// last node called for switch
	long		switchstart;    // starting iD
	String		SubDir;			// the current subdir for offsetted adding
	bool		ValMayChange;	// switch may change

	// variable helpers
	bool BoolChanged(bool &b);
	bool SwitchChanged(long &s);
		
	CMenu *AddMenu(){CMenu *m=new CMenu();m->CreatePopupMenu();menulist.Add(m);return(m);}

	void SetOffset(String &o){SubDir=o;}
};

//---------------------------------------------------------------------------

#endif
