// Progress.cpp : implementation file
//

#include "mfctools.h"
#include "Progress.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgress dialog
//------------------------------------------------------------------------------
CProgress *win=NULL;
long	   winreference=0;

void  ProgressWindowOpen(char *title,char *frame, bool showtime)
{
	if (win==NULL)
	{	String t=title,f=frame;
		win=new CProgress(showtime,t,f,NULL);
	}
	winreference++;
}
//------------------------------------------------------------------------------

void  ProgressWindowClose()
{
	winreference--;
	if (winreference==0)close_winptrwindow((void **)&win);
}

//------------------------------------------------------------------------------
void  ProgressWindowSet(char *report,float fac)
{
	if(win!=NULL)
	{
		String r=report;
		sendmessage_winptr(win,_DTMSG_CUSTOM1,(long)&r,(long)&fac);
	};
}

//------------------------------------------------------------------------------
void  ProgressWindowTween(char *tween)
{
	if(win!=NULL)
	{
		String t=tween;
		sendmessage_winptr(win,_DTMSG_CUSTOM2,(long)&t);
	};
}

//------------------------------------------------------------------------------

CProgress::CProgress(bool showtime,String &title,String &frame,CWnd* pParent /*=NULL*/)
	: CDialogTool(CProgress::IDD, pParent)
{
	factor=0;
	CreateDlg(IDD,pParent);
	String t;t.SetWnd(&m_Title); // clear title
	title.SetWnd(this);
	frame.SetWnd(&m_Frame);
	GetControlRect(&m_Prog,&rcf,3,3,3,3);
	//{{AFX_DATA_INIT(CProgress)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgress)
	DDX_Control(pDX, IDC_TWEENN, m_Tween);
	DDX_Control(pDX, IDC_TITLEN, m_Title);
	DDX_Control(pDX, IDC_TIMEN, m_Time);
	DDX_Control(pDX, IDC_PROGRESS, m_Prog);
	DDX_Control(pDX, IDC_FRAMEN, m_Frame);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgress, CDialog)
	//{{AFX_MSG_MAP(CProgress)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDCLOSE, OnClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgress message handlers

void CProgress::OnTimer(UINT nIDEvent) 
{
	time_t ltime;
	time( &ltime );
	char timendate[26];sprintf(timendate,"%s",ctime( &ltime ));timendate[24]=' ';timendate[25]=0;
	String t=timendate;
	t.SetWnd(&m_Time);
	CDialog::OnTimer(nIDEvent);
}

void CProgress::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CRect rcp;
	// now draw the progress bar in the rc..
	CBrush	 backbrush,fillbrush;
	backbrush.CreateSolidBrush(RGB(32,32,32));
	fillbrush.CreateSolidBrush(RGB(0,255,0));
	
	//CGdiObject *oldpen,*oldbrush,*oldfont;	
	dc.FillRect(rcf,&backbrush);
	rcp.left	=rcf.left;
	rcp.top		=rcf.top;
	rcp.bottom	=rcf.bottom;
	rcp.right	=rcf.left+(float)(rcf.right-rcf.left)*factor;
	dc.FillRect(rcp,&fillbrush);
}

long CProgress::message_handler(long msg,long dta1,long dta2)
{
	if (msg==_DTMSG_CUSTOM1)
	{ // dta1 is pointer to msg, dta2 is pointer to float
		String *t=(String *)dta1;
		factor=*(float *)dta2;
		t->SetWnd(&m_Title);
		// update 'percentage'
		String f;f.Format("%2.1f%%",factor*100.0f);f.SetWnd(&m_Time);
		InvalidateRect(&rcf);
		MSG msg;
		while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) 
		{ 
			if ( !MainWinAppPtr->PumpMessage( ) ) 
			{ 
				//::MainWinAppPtr->PostQuitMessage( ); 
				break; 
			} 
		} 
		// let MFC do its idle processing
		LONG lIdle = 0;
		while ( AfxGetApp()->OnIdle(lIdle++ ) );
		
		t->SetWnd(&m_Title);
		f.SetWnd(&m_Time);
		
	}
	if (msg==_DTMSG_CUSTOM2)
	{ // dta1 is pointer to msg, dta2 is pointer to float
		String *t=(String *)dta1;
		t->SetWnd(&m_Tween);
		// update 'percentage'

		MSG msg;
		while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) 
		{ 
			if ( !MainWinAppPtr->PumpMessage( ) ) 
			{ 
				//::MainWinAppPtr->PostQuitMessage( ); 
				break; 
			} 
		} 
		// let MFC do its idle processing
		LONG lIdle = 0;
		while ( AfxGetApp()->OnIdle(lIdle++ ) );
		
		t->SetWnd(&m_Tween);
	}


	return(0);
}

void CProgress::OnClose() 
{
		
}

void CProgress::OnOK() 
{
			
}

void CProgress::OnCancel() 
{

}
