/*
---------------------------------------------------------------------------
|				String classes and string utility functions.
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
Requirements:
	
Changes:
	Wendsday 20th december:	Initial file setup
*/
#include "Library.h"

//----------------------------------------------------------------------------------------
// Function parses trees like "\\code\\base\\whee"
// Where level 0 = code level 1= base and level 2=whee
//---------------------------------------------------------------------------

String&	String::FormatGet(const char *fmt, ...)					
{
	return *this;
}

//---------------------------------------------------------------------------

String&	String::Format(const char *fmt, ...)
{
	va_list params;va_start(params, fmt);    
	char temp[TEMPSTRINGSIZE];Copy(temp,vsprintf(temp,fmt,params)+1);
	return *this;
}

//---------------------------------------------------------------------------

String&	String::FormatAdd(const char *fmt, ...)			
{
	va_list params;va_start(params, fmt);    
	char temp[TEMPSTRINGSIZE];Concat(temp,vsprintf(temp,fmt,params)+1);
	return *this;
}

//---------------------------------------------------------------------------
// Mathematical string formatting.
#define NFRAC 8*12
#define NSPEC 16
#define OPER  6

double commontable[NFRAC*NSPEC*OPER];
char   *commontable_t[NFRAC*NSPEC*OPER];

struct _execute_makespectables{_execute_makespectables()
{
	
	char  *spec_t[NSPEC];
	double spec_d[NSPEC];
	char  *frac_t[NFRAC];
	double frac_d[NFRAC];
	double i,j,k;char temp[100];
	long l,x,y;

	//make special
	spec_t[0]=cpystring("Pi\0");		spec_d[0]=PI;
	spec_t[1]=cpystring("e\0");			spec_d[1]=E;
	spec_t[2]=cpystring("sqr(2)\0");	spec_d[2]=sqrt(2.0);
	spec_t[3]=cpystring("sqr(3)\0");	spec_d[3]=sqrt(3.0);
	spec_t[4]=cpystring("sqr(5)\0");	spec_d[4]=sqrt(5.0);
	spec_t[5]=cpystring("sqr(6)\0");	spec_d[5]=sqrt(6.0);
	spec_t[6]=cpystring("sqr(7)\0");	spec_d[6]=sqrt(7.0);
	spec_t[7]=cpystring("sqr(Pi)\0");	spec_d[7]=sqrt(PI);
	spec_t[8]=cpystring("sqr(e)\0");		spec_d[8]=sqrt(E);
	spec_t[9]=cpystring("Pi^2\0");		spec_d[9]=PI*PI;
	spec_t[10]=cpystring("e^2\0");		spec_d[10]=E*E;
	spec_t[11]=cpystring("e^3\0");		spec_d[11]=E*E*E;
	spec_t[12]=cpystring("ln(2)\0");	spec_d[12]=log(2.0f);
	spec_t[13]=cpystring("ln(3)\0");	spec_d[13]=log(3.0f);
	spec_t[14]=cpystring("ln(4)\0");	spec_d[14]=log(4.0f);
	spec_t[15]=cpystring("ln(5)\0");	spec_d[15]=log(5.0f);
	
	// Makes different fractions..
	l=0;
	for (i=0;i<8;i++) // base number
	{
		// add 0 divider
		sprintf(temp,"%d",(long)i);
		frac_t[l]=cpystring(temp);frac_d[l]=i;l++;

		for (j=2;j<=6;j++) // divider
		{
			if (fmod(j,2)==0)
			{
				if (i!=0)
					sprintf(temp,"%d,%d,%d",(long)i,1,(long)j);
				else
					sprintf(temp,"%d,%d",1,(long)j);
				frac_t[l]=cpystring(temp);
				frac_d[l]=i+1.0/j;
				l++;
				if (j-1!=1)
				{
					if (i!=0)
						sprintf(temp,"%d,%d,%d",(long)i,(long)j-1,(long)j);
					else
						sprintf(temp,"%d,%d",(long)j-1,(long)j);

					frac_t[l]=cpystring(temp);
					frac_d[l]=i+(j-1)/j;
					l++;
				}
			}
			else
			{
				for (k=1;k<=j-1;k++)
				{
					if (i!=0)
						sprintf(temp,"%d,%d,%d",(long)i,(long)k,(long)j);	
					else
						sprintf(temp,"%d,%d",(long)k,(long)j);	
					frac_t[l]=cpystring(temp);
					frac_d[l]=i+k/j;
					l++;
				}

			}
		}
	}
	//Now go stuff it in a table .. 
	l=0;
	for (x=0;x<NFRAC;x++) // fractional parts
	{	
		for (y=0;y<NSPEC;y++)
		{
			// order is: + - * /
			if (frac_d[x]==0)
			{
				sprintf(temp,"%s",spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]  =spec_d[y];l++;
				sprintf(temp,"-%s",spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]-spec_d[y];l++;
				sprintf(temp,"0");commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]*spec_d[y];l++;
				sprintf(temp,"0");commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]/spec_d[y];l++;
				sprintf(temp,"1/%s",spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=1.0/(frac_d[x]+spec_d[y]);l++;
				sprintf(temp,"1/-%s)",spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=1.0/(frac_d[x]-spec_d[y]);l++;
			}
			else
			{
				sprintf(temp,"%s+%s",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]  =frac_d[x]+spec_d[y];l++;
				sprintf(temp,"%s-%s",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]-spec_d[y];l++;
				sprintf(temp,"%s%s",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]*spec_d[y];l++;
				sprintf(temp,"%s/%s",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=frac_d[x]/spec_d[y];l++;
				sprintf(temp,"1/(%s+%s)",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=1.0/(frac_d[x]+spec_d[y]);l++;
				sprintf(temp,"1/(%s-%s)",frac_t[x],spec_t[y]);commontable_t[l]  =cpystring(temp);
				commontable[l]=1.0/(frac_d[x]-spec_d[y]);l++;
			}
		}
	}
	// delete the strings..
	for (x=0;x<NSPEC;x++)delete spec_t[x];
	for (x=0;x<NFRAC;x++)delete frac_t[x];
};
~_execute_makespectables()
{
	for (long i=0;i<NFRAC*NSPEC*OPER;i++)delete commontable_t[i];
}
}execute_makespectables;

//-------------------------------------------------------

String&	String::FormatBin(long d,short bits)
{
	char out[100];
	long bit=1,pos=0,len=1<<(long)bits; // convert to longeger..
	while (d!=0)
	{
		if (bit>=len)break;
		if ((d&bit)!=0)out[pos]='1';
		else out[pos]='0';
		pos++;
		d-=d&bit;bit=(bit<<1);
	}
	// now reverse it longo the output buffer..
	AllocBuffer(pos+2);
	pData[0]='#';
	long i,j;
	for (i=pos-1,j=1;i>=0;i--,j++)
		pData[j]=out[i];
	pData[j]=0;
	return *this;
}

//-------------------------------------------------------

String&	String::FormatHex(long value,short bits)			// Hex mode
{
	//if (value>4294967295.0 || value<4294967295.0)
	//{
		//*this="$ffffffff";
		//return *this;
	//}
	char out[100];
	static char hextbl[]="0123456789abcdef";
	long d=(long)value,fac=1,pos=0,bitpos=0; // convert to longeger..
	while (d!=0 && bitpos<bits)
	{
		fac=15<<bitpos;
		out[pos]=hextbl[((d&fac)>>bitpos)];
		d-=d&fac;bitpos+=4;pos++;
	}
	// now reverse it longo the output buffer..
	AllocBuffer(pos+2);
	pData[0]='$';
	long i,j;
	for (i=pos-1,j=1;i>=0;i--,j++)
		pData[j]=out[i];
	pData[j]=0;
	return *this;
}

//-------------------------------------------------------

String&	String::FormatBool(bool value)							// Prlongs True or False
{
	if (value)(*this)="True";
	else (*this)="False";
	return *this;
}

//-------------------------------------------------------
 

String&	String::FormatSpec(double value,short digits,short mode,double flimit)// converts to one mode of 2 (0=normal) (1=special)
{
	char where[TEMPSTRINGSIZE];
	long len=0;
	char *ret;long dec,fsign;
	if (mode==5) // short scientific
	{
		digits=3;
		//1.2344*10^3
		double t=value;
		double neg=false;
		if (t<0)t*=-1,neg=true;
		long p=0;
		if (t==0){*this="0";return(*this);}
		if (t<1)
		{
			while(t<1)t*=10,p--;
		}
		else
		if (t>10)
		{
			while(t>10)t/=10,p++;
		}
		else 
		{
			String v;
			if (neg)v.Format("-%%1.%df",digits);
			else    v.Format("%%1.%df",digits);
			Format(v,t);return(*this);
			//Format("%1.5f",t);return(*this);
		}
		String v;
		if (neg)v.Format("-%%1.%df'%%ld",digits);
		else    v.Format("%%1.%df'%%ld",digits);
		Format(v,t,p);
		//Format("%1.5f*10^%ld",t,p);
		return(*this);
	}
	if (mode==4) // scientific
	{
		digits=7;
		//1.2344*10^3
		double t=value;
		double neg=false;
		if (t<0)t*=-1,neg=true;
		long p=0;
		if (t==0){*this="0";return(*this);}
		if (t<1)
		{
			while(t<1)t*=10,p--;
		}
		else
		if (t>10)
		{
			while(t>10)t/=10,p++;
		}
		else 
		{
			String v;
			if (neg)v.Format("-%%1.%df",digits);
			else    v.Format("%%1.%df",digits);
			Format(v,t);return(*this);
			//Format("%1.5f",t);return(*this);
		}
		String v;
		if (neg)v.Format("-%%1.%df*10^%%ld",digits);
		else    v.Format("%%1.%df*10^%%ld",digits);
		Format(v,t,p);
		//Format("%1.5f*10^%ld",t,p);
		return(*this);
	}
	if (mode==3) // binary
	{
		return(FormatBin(cast32bit(value),28));
	}
	if (mode==2) // hex
	{
		return(FormatHex(cast32bit(value),28));
	}
	if (mode==1) // fractional/normal
	{
		// First go check if it's a normal 'breuk' to 1/1000th
		double x=value;
		double a,b=1,c=2,d,f=1;
		long i;
			
		if (value<0)value*=-1,f=-1;

		a=floor(value);
		
		if (fabs(value-a)>flimit)
		{
	
			value-=a;

			where[0]=0;
			while(c<=1000)
			{
				d = b / c;
				if (fabs(value-d)<flimit)
				{
				
					if (a!=0)
						len=sprintf(where,"%.0f,%.0f,%.0f",a*f,b,c)+1;
					else
						len=sprintf(where,"%.0f,%.0f",b*f,c)+1;
					Copy(where,len);return *this;
				}
				if (value > d)b++,c++;
				else c++;
			}

			// Now go look in the common table..
			value+=a;
			for (i=0;i<NFRAC*NSPEC*OPER;i++)
			{
				if (fabs(value-commontable[i])<flimit)
				{
					//decode offset..
					char *s=" ";
				
					if (f==-1)len=sprintf(where,"-%s",commontable_t[i])+1;
					else len=sprintf(where,"%s",commontable_t[i])+1;
					Copy(where,len);
					return *this;
				}	
			}
		}
		value=x;
	}
	// not found or mode is 0
	int dc,fsgn;
	ret=_ecvt(value,digits,&dc,&fsgn);
	dec=dc;fsign=fsgn;
	where[0]=0;_copychar(where,ret,strlen(ret)+1);
	if (dec==0){_insertchar(where,0,'.');_insertchar(where,0,'0');}
	else if (dec>0)_insertchar(where,dec,'.');
	else // pad withs starting zeroes
	{
		while (dec<0){_insertchar(where,0,'0');dec++;}
		_insertchar(where,0,'.');_insertchar(where,0,'0');
		where[digits+2]=0; // cut off at specified 'digit count'
	}
	if (fsign!=0)_insertchar(where,0,'-');
	Copy(where,strlen(where)+1);
	return(*this);
}

//----------------------------------------------------------

bool	String::FindEvenPair(char a,char b,long &start,long &end,long pos,bool sameline) const
{
	long i,j=0;
	for (i=pos;i<Len && (!sameline || pData[i]!='\n');i++)
	{
		if (pData[i]==a)
		{
			if(j==0)start=i;
			j++;
		}
		else if (pData[i]==b)
		{
			j--;
			if (j==0){end=i;return(true);}
		}
	}
	return(false);
}

//----------------------------------------------------------

bool	String::FindComments(long &start,long &end,long pos) const// finds /* */ and // \n paris
{
	bool StartSet=false,CppComm=false;
	for (long i=pos;i<Len-1;i++)
	{
		if (pData[i]=='/' && pData[i+1]=='*')if (!StartSet)StartSet=true,start=i;
		if (pData[i]=='/' && pData[i+1]=='//')if (!StartSet)StartSet=true,CppComm=true,start=i;
		if (pData[i]=='\n' && CppComm){end=i;return true;}
		if (pData[i]=='*' && pData[i+1]=='/')if (StartSet){end=i;return true;}
	};
	if (CppComm==true)return true;
	return false;
}

//----------------------------------------------------------

long	String::Find(const char *str, long pos ) const
{
	long i,j;	
	for (i=pos;i<Len;i++)
	{
		for (j=i;;j++)
		{
			if (str[j-i]==0)return(i);
			if (pData[j]==0)return(-1);
			if (pData[j]!=str[j-i])break;
		}
	}
	return(-1);
}

//-------------------------------------------------------
long	String::FindLen(const char *str, long &len) const
{
	long i,j;	
	for (i=0;i<Len;i++)
	{
		for (j=i;;j++)
		{
			if (str[j-i]==0){len=j-i;return(i);}
			if (pData[j]==0)return(-1);
			if (pData[j]!=str[j-i])break;
		}
	}
	return(-1);
}

//-------------------------------------------------------

long	String::FindNoCase(const char *str, long pos ) const
{
	long i,j;	
	for (i=pos;i<Len;i++)
	{
		for (j=i;;j++)
		{
			if (str[j-i]==0)return(i);
			if (pData[j]==0)return(-1);
			if (toLower(pData[j])!=toLower(str[j-i]))break;
		}
	}
	return(-1);
}

//-------------------------------------------------------


double	String::Eval()
{
	FuncTree parsetree;parsetree.Create(*this);
	return(parsetree.Calculate());
}

//----------------------------------------------------------

long 	String::GetLine(long l,String *st,long t)
{
	char temp[TEMPSTRINGSIZE];

	long i=0,s=0; // find the right line

	if (t==0)
	{
		while (s<l)
		{
			if (pData[t]=='\n')s++;t++;
			if (t>=Len)return(-1);
		}
	} 
	else if (t>=Len || t<0)return(-1);
	
	for (i=0; (t+i)<Len && pData[t+i]!='\n' && pData[t+i]!=0;i++)temp[i]=pData[t+i];
	if (i==0)return(-1);
	temp[i]=0;

	*st=temp;

	return(t+i+1);
}

//----------------------------------------------------------
	String::String()						{pData=NULL;AllocBuffer(1);}
	String::String(char c)					{pData=NULL;AllocBuffer(2);pData[0]=c;pData[1]=0;}
	String::String(char c, long len)			{pData=NULL;AllocBuffer(len+1);for (long i=0;i<len;i++)pData[i]=c;pData[len]=0;}
	String::String(const char *str)			{pData=NULL;long i;for (i=0;str[i]!=0;i++);AllocBuffer(i+1);memcpy(pData,str,Len);}
	String::String(const char *str, long len){pData=NULL;AllocBuffer(len+1);memcpy(pData,str,Len);pData[len]=0;}
	String::String(cString str)				{pData=NULL;AllocBuffer(str.Length());memcpy(pData,str.GetReadPtr(),Len);}
	String::String(cString str, long len)	{pData=NULL;AllocBuffer(len);memcpy(pData,str.GetReadPtr(),Len);}
	String::String(const char *src1, long src1_len, const char *src2, long src2_len)
											{pData=NULL;AllocBuffer(src1_len+src2_len-1);memcpy(pData,src1,src1_len);memcpy(&pData[src1_len-1],src2,src2_len);}
	String::String(long val)					{pData=NULL;char temp[100];AllocBuffer(sprintf(temp,"%ld",val)+1);memcpy(pData,temp,Len);}
	String::String(ulong val)				{pData=NULL;char temp[100];AllocBuffer(sprintf(temp,"%ld",val)+1);memcpy(pData,temp,Len);}
	String::String(float val)				{pData=NULL;char temp[100];AllocBuffer(sprintf(temp,"%f", val)+1);memcpy(pData,temp,Len);}
	String::String(double val)				{pData=NULL;char temp[100];AllocBuffer(sprintf(temp,"%f", val)+1);memcpy(pData,temp,Len);}
	String::~String()						{delete pData;}

	// Operations
	void	String::Clear()											{ AllocBuffer(1); }
	cString	String::Reverse()										{ for (long i1=0, i2=Len-1; i1<i2; i1++, i2--) swapc(&pData[i1], &pData[i2]); return *this; }

	// Properties
	bool		String::IsUpper() const									{ for (long i=0;i<Len;i++)if (isLower(pData[i]))return(false);return(true);}
	bool		String::IsLower() const									{ for (long i=0;i<Len;i++)if (isUpper(pData[i]))return(false);return(true);}
	bool		String::IsEmpty() const									{ return Len==1; }
	long			String::Length() const									{ return Len; }
	long			String::SLength() const									{ return Len-1; }
	// Data access
	String&		String::SetLength(long len)								{ AllocBuffer(len,true); Len=len; pData[len-1]=0; return *this; }
	char		String::GetAt(long pos) const							{ assert(pos<Len); return pData[pos]; }
	void		String::SetAt(long pos, char c)							{ assert(pos<Len); pData[pos]=c; }
	//BUG>>>>  FIX IT
	void		String::Insert(long pos, cString str)					{ long slen=Len,dlen=str.Length()-1; AllocBuffer(Len+dlen,true);for (long i=slen-1;i>=pos;i--)pData[i+dlen]=pData[i];memcpy(&pData[pos],str.GetReadPtr(),dlen);}	
	void		String::Insert(long pos, long num, cString str)			{ long slen=Len,dlen=num;            AllocBuffer(Len+dlen,true);for (long i=slen-1;i>=pos;i--)pData[i+dlen]=pData[i];memcpy(&pData[pos],str.GetReadPtr(),dlen);}	
	void		String::Delete(long pos, long len)						{ if (pos+len>=Len)len=Len-pos-1;for (long i=pos+len;i<Len;i++)pData[i-len]=pData[i];pData[Len-len-1]=0;AllocBuffer(Len-len,true);}
	void		String::Overwrite(long pos, cString str)					{ long dlen=str.Length()-1; if (pos+dlen>Len-1)AllocBuffer(pos+dlen+1,true);memcpy(&pData[pos],str.GetReadPtr(),dlen);pData[Len-1]=0;}
	void		String::Replace(long pos, long num, cString str)			{ Delete(pos,num);Insert(pos,str);}

	// Substrings
	String		String::Left(long num) const								{ num = min(num, Len); return String(pData, num); }
	String		String::Right(long num) const							{ num = min(num, Len); return String(pData+Len-num, num); }
	String		String::RightL(long num) const							{ num = min(num, Len); return String(pData+num, Len-num+1); }
	String		String::Mid(long pos, long num) const						{ pos = min(pos, Len); num = min(num, Len-pos); return String(pData+pos, num); }

	// Comparison
	long			String::Compare(cString rhs) const						{ return(strcmp(pData,rhs.GetReadPtr() ));}
	long			String::CompareNoCase(cString rhs) const				{ return(_stricmp(pData,rhs.GetReadPtr() ));}
	bool		String::IsEqual(cString rhs) const						{ return (Compare(rhs)==0); }
	bool		String::IsEqualNoCase(cString rhs) const				{ return (CompareNoCase(rhs)==0); }

	// Search/replace
	long			String::Find(char c, long pos) const					{ for (long i=pos;i<Len;i++)if (pData[i]==c)return(i);return(-1);}
	long			String::FindL(char c) const							{ long j=-1;for (long i=0;i<Len;i++)if (pData[i]==c)j=i;return j;}
	long			String::Find(cString str, long pos) const			{return(Find((const char *)GetReadPtr(),pos));}
	long			String::FindOneOf(const char *cset, long pos) const	{for (long i=0;i<Len-1;i++)if (inset(cset,pData[i])==true)return(i);return(-1);}
	long			String::CountChar(char c,long pos) const				{long cnt=0;for (long i=pos;i<Len-1;i++)if (pData[i]==c)cnt++;return(cnt);}
	// 
	String		String::GetRegion(long start,long end)					{char temp[1024];for (long i=start;i<Len && i<end;i++)temp[i-start]=pData[i];temp[end-start]=0;return String(temp);}
 
	// Formatting
	String&		String::Upper()											{for (long i=0;i<Len;i++)pData[i]=toUpper(pData[i]);return (*this);}
	String&		String::Lower()											{for (long i=0;i<Len;i++)pData[i]=toLower(pData[i]);return (*this);}
	String&		String::TrimLeft()										{long i;for (i=0;i<Len-1 && (pData[i]==' ' || pData[i]=='\t');i++);if (i!=0);Delete(0,i);return (*this);}
	String&		String::TrimLeft(char *set)								{long i;for (i=0;i<Len-1 && inset(set,pData[i]);i++);if (i!=0);Delete(0,i);return (*this);}
	String&		String::TrimRight()										{long i;for ( i=Len-2;i>=0 && (pData[i]==' ' || pData[i]=='\t');i--);return (SetLength(i+2));}
	String&		String::TrimRight(char *set)							{long i;for ( i=Len-2;i>=0 && inset(set,pData[i]);i--);return (SetLength(i+2));}
	String&		String::Trim()											{TrimLeft();return(TrimRight());}
	String&		String::Trim(char *set)									{TrimLeft(set);return(TrimRight(set));}		

	double		String::ToDouble() const									{ return (double)atof((const char *)pData); }
	float		String::ToFloat() const								{ return (float)atof((const char *)pData); }
	long			String::Tolong() const									{ return atoi((const char *)pData); }
	bool		String::ToBool() const									{ return (IsEqual("1") || IsEqualNoCase("true") || IsEqualNoCase("yes")); }


	//TODO finish this.. get text from a CWnd object.......
	void   String::SetWnd(void *w)									{MFCWrap_Call(MFCW_SETTEXT,(long)w,(long)pData);}
	String &String::GetWnd(void *w)									{char temp[1024];temp[0]=0;MFCWrap_Call(MFCW_GETTEXT,(long)w,(long)temp,1024);*this=temp;return (*this);}
	void   String::MsgBox()											{MFCWrap_Call(MFCW_MSGBOX,(long)pData);}

	// Makes sure memory is alloced in the vfcore dll..
	void   String::AllocBuffer(long len, bool keep_contents)
	{	
		assert(len>0);
		if (pData==NULL){pData=new char[len];pData[len-1]=0;}
		else
		if (len!=Len)
		{
			long clen=Len;if (clen>len)clen=len;
			if (keep_contents==true)
			{char *temp=pData;pData=new char [len];memcpy(pData,temp,clen);delete temp;}
			else {delete pData;pData=new char [len];}
			pData[len-1]=0;
		}
		Len=len;
	}

//--------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------
//--  File name class
//--------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------

//
// Get the base path for a file (no filename)					e.g. "/dev/etc/file.ext" -> "/dev/etc/"
//
FileName FileName::BasePath() const
{
	long file_pos = max(FindL('\\'), FindL('/'));
	return (file_pos>0) ? Left(file_pos+1) : String("");
}
//------------------------------------------------------------------------------------
//
// Get base name of file (no extension)							e.g. "/dev/etc/file.exe" -> "/dev/etc/file"
//
FileName FileName::BaseName() const
{
	long ext_pos  = FindL('.');
	long file_pos = max(FindL('\\'), FindL('/'));
	return ((ext_pos!=-1) && (ext_pos>file_pos)) ? Left(ext_pos) : String("");
}

// Get base name of file (no extension)							e.g. "/dev/etc/file.exe" -> "file.exe"

FileName FileName::Name(bool withext) const
{
	long ext_pos  = FindL('.');
	long i;
	for (i=Length()-1;i>=0 && pData[i]!='\\' && pData[i]!='/';i--);
	if (withext)
		return Mid(i+1,Length()-i);
	else
		return Mid(i+1,ext_pos-i);
}

//
// Get extension of file										e.g. "/dev/etc/file.exe" -> "exe"
//
FileName FileName::Extension() const
{
	long ext_pos  = FindL('.');
	long file_pos = max(FindL('\\'), FindL('/'));
	return ((ext_pos!=-1) && (ext_pos>file_pos)) ? Mid(ext_pos+1) : String("");
}

//
// Check if the specified filename is a full path (i.e. not a relative path)
//
bool FileName::IsFullPath() const
{
	if (Len < 2) return false;
	if (pData[0]=='\\') return true;							// "\File" polongs to root
	if (Len < 4) return false;
	if (pData[1] == ':') return true;							// "X:\" DOS path
	if (pData[0]=='\\' && pData[1]=='\\') return true;			// "\\server" UNC path
	return false;												// None of the above
}

//------------------------------------------------------------------------------------

long FileName::GetPathLevel(String *t,short level)
{
	short levelcount=-1,i;
	for (i=0;pData[i]!=0 && i<Len ;i++)
		if (pData[i]=='\\' || pData[i]=='/' || ( ( pData[0]!='\\' && pData[0]!='/') && i==0 ))
		{
			levelcount++;
			if (levelcount==level)
			{
				if (pData[i]=='\\' || pData[i]=='/')i++;
				long start=i;
				long end=i;

				if (pData[i]==0) // got an end
				{
					*t="";
					return(GP_IS_END);
				}
				for (; pData[end]!=0 && pData[end] != '\\' && pData[i]!= '/'; end++);
				//end--;
				if (start!=end)
					*t=GetRegion(start,end);				
				else
				{
					*t="";
				}
				if (pData[end]==0)return(GP_IS_END);

				return(GP_IS_BEFOREND);
			}
	}
	return(GP_IS_PASTEND);
}

//------------------------------------------------------------------------------------