
/*
---------------------------------------------------------------------------
|				String classes and string utility functions.
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#ifndef _H_STRING
#define _H_STRING

// allocates new space for string *src
inline char *cpystring(char *src)											{char *t;if (src==NULL)return(NULL);long i=0,j;for (i=0;src[i]!=0;i++);t=new char[i+1];for (j=0;j<=i;j++)t[j]=src[j];return t;}

// Some basic string helper functions.. inlined and all
// TODO optimize and clean em up..
inline bool _stringcmp(char *what, char *where)								{	if (what==where)return true;if (what==NULL || where==NULL)return false;for (long i=0;;i++){if (what[i]==0)break;if (where[i]==0)return false;if (toLower(what[i])!=toLower(where[i]))return false;	}return true;}
inline bool _stringcmp(char *what, char *where,long len)					{	if (what==where)return true;	if (what==NULL || where==NULL)return false;	for (long i=0;i<len;i++){	if (what[i]==0)break;if (where[i]==0)return false;if (toLower(what[i])!=toLower(where[i]))return false;}return true;}
inline void _insertchar(char *where, short offset, char what)				{	char swap=what,temp;for (short i=offset;;i++){	temp=where[i];	where[i]=swap;	if (swap==0)break;	swap=temp;}}
inline void _deletechar(char *where, short offset)							{	for (short i=offset;;i++){if (where[i]==0)break;where[i]=where[i+1];if (where[i]==0)break;};}
inline void _replacechar(char *where, short offset, short length, char with){	for (short j=0;j<length;j++)for (short i=offset;;i++){if (where[i]==0)break;where[i]=where[i+1];if (where[i]==0)break;}char swap=with,temp;	for (short i=offset;;i++){	temp=where[i];where[i]=swap;if (swap==0)break;swap=temp;}}
inline void _copychar(char *d,char *s,long len)								{	bool addzero=false;long i;if (len==-1){	for (i=0;;i++){	if (d[i]==0)addzero=true;	d[i]=s[i];if (s[i]==0)break;}}else{for (i=0;i<len;i++){if (d[i]==0)addzero=true;d[i]=s[i];if (s[i]==0)break;}}if (addzero==true)d[i]=0;	}
//----------------------------------------------------------

DECLARE_CLASS(String)

// minimum amount of string length difference in order for it to be reallocated
#define STRINGMINREALLOC 10
#define TEMPSTRINGSIZE	 1024				// Used in the formatting stuff
// NOTE!!!!!! ALL LENGTHs..include the ending 0 .. so a length of 1 .. is an empty string

enum
{
	SFM_NORMAL			=0,
	SFM_FRACTIONAL		=1,
	SFM_HEX				=2,
	SFM_BINARY			=3,
	SFM_SCIENTIFIC		=4,
	SFM_SCIENTIFICSHORT	=5

};

class  String
{
public:
	// Initialization
	String();
	String(char c);
	String(char c, long len);
	String(const char *str);
	String(const char *str, long len);
	String(cString str);
	String(cString str, long len);
	String(const char *src1, long src1_len, const char *src2, long src2_len);
	String(long val);
	String(ulong val);
	String(float val);
	String(double val);
	~String();

	// Operations
	String&			Format(const char *fmt, ...);					
	String&			FormatGet(const char *fmt, ...);					
	String&			FormatAdd(const char *fmt, ...);				
	String&			FormatBin(long value,short bits=28);			// Binary mode
	String&			FormatHex(long value,short bits=28);			// Hex mode
	String&			FormatBool(bool value);							// Prlongs True or False
	String&			FormatSpec(double value,short digits=15,short mode=0,double flimit=TINYLIMIT);			// converts to one mode of 3
	void			Clear();
	cString			Reverse();

	// Properties
	bool		IsUpper() const;
	bool		IsLower() const;
	bool		IsEmpty() const;
	long			Length() const;
	long			SLength() const;
	String		GetRegion(long start,long end);

	// Data access
	String&		SetLength(long len);
	char		GetAt(long pos) const;
	void		SetAt(long pos, char c);
	//BUG>>>>  FIX IT
	void		Insert(long pos, cString str);
	void		Insert(long pos, long num, cString str);
	void		Delete(long pos, long len);
	void		Overwrite(long pos, cString str);
	void		Replace(long pos, long num, cString str);

	// Substrings
	String	Left(long num) const;
	String	Right(long num) const;
	String	RightL(long num) const;
	String	Mid(long pos, long num = INT_MAX) const;

	// Comparison
	long		Compare(cString rhs) const;
	long		CompareNoCase(cString rhs) const;
	bool	IsEqual(cString rhs) const;
	bool	IsEqualNoCase(cString rhs) const;

	// Search/replace
	long		Find(char c, long pos = 0) const;
	long		FindL(char c) const;
	long		Find(const char *str, long pos = 0) const;		
	long		FindLen(const char *str, long &len) const;		
	long		FindNoCase(const char *str, long pos = 0) const;		
	long		Find(cString str, long pos = 0) const;
	long		FindOneOf(const char *cset, long pos = 0) const;
	bool		FindEvenPair(char a,char b,long &start,long &end,long pos = 0,bool sameline=false) const;		// finds ( ) pairs
	bool		FindComments(long &start,long &end,long pos) const;// finds /* */ and // \n paris
	long		CountChar(char c,long pos) const;
	// Formatting
	
	String&	Upper();
	String&	Lower();
	String&	TrimLeft();
	String&	TrimLeft(char *set);
	String&	TrimRight();
	String&	TrimRight(char *set);
	String&	Trim();
	String&	Trim(char *set);

	// Math thing
	double Eval();	// Evaluates the string using the function tree system..

	// Conversions
	inline operator char*()											{ return pData; }
	inline char		*GetPtr()										{ return pData; }
	inline operator const char *() const							{ return (const char *)pData; }
	const char		*GetReadPtr() const								{ return (const char *)pData; }
	double			ToDouble() const;
	float			ToFloat() const;
	long				Tolong() const;	
	bool			ToBool() const;	
	long			GetLine(long l,String *st,long t=0);
	
	// array like xs
	//inline char  & operator[](long pos)								{ if (pos>=0 && pos<Len)return pData[pos];return pData[0];}

	// String as a stream
	inline String& operator<<(const long& val)						{FormatAdd("%ld",val);return *this;}
	inline String& operator<<(const ulong& val)						{FormatAdd("%ld",val);return *this;}
	inline String& operator<<(const float& val)						{FormatAdd("%f", val);return *this;}
	inline String& operator<<(const double& val)					{FormatAdd("%f", val);return *this;}	
	inline String& operator<<(cString rhs)							{ *this += rhs; return *this; }
	inline String& operator<<(const char *rhs)						{ *this += rhs; return *this; }
		// Operators
	//inline cString	operator=(const byte *rhs)						{ return Copy((char *)rhs, strlen((char *)rhs)+1); }
	inline cString	operator=(cString rhs)							{ return Copy(rhs.GetReadPtr(), rhs.Length()); }
	inline cString	operator=(char rhs)								{ return Copy(&rhs, 2); }
	inline cString	operator=(const char *rhs)						{ return Copy(rhs, strlen(rhs)+1); }
	inline cString	operator=(long rhs)								{ return Format("%ld",rhs);}
	inline cString	operator=(float rhs)							{ return Format("%f",rhs);}
	inline cString	operator=(double rhs)							{ return Format("%f",rhs);}

	inline cString	operator+=(const char *rhs)						{ return Concat(rhs, strlen(rhs)+1); }
	inline cString	operator+=(cString rhs)							{ return Concat(rhs.GetReadPtr(), rhs.Length()); }
	inline cString	operator+=(char rhs)							{ return Concat(&rhs, 1); }

	inline friend String operator+(cString      lhs, cString     rhs) { return String(lhs.GetReadPtr(), lhs.Length(), rhs.GetReadPtr(), rhs.Length()); }
	inline friend String operator+(cString      lhs, char        rhs) { return String(lhs.GetReadPtr(), lhs.Length(), &rhs, 1); }
	inline friend String operator+(char         lhs, cString     rhs) { return String(&lhs, 1, rhs.GetReadPtr(), rhs.Length()); }
	inline friend String operator+(cString      lhs, const char *rhs) { return String(lhs.GetReadPtr(), lhs.Length(), rhs, strlen(rhs)+1); }
	inline friend String operator+(const char  *lhs, cString     rhs) { return String(lhs, strlen(lhs)+1, rhs.GetReadPtr(), rhs.Length()); }

	inline friend bool operator<(cString      lhs, cString     rhs) { return (strcmp(lhs, rhs)<0); }
	inline friend bool operator<(cString      lhs, const char *rhs) { return (strcmp(lhs, rhs)<0); };
	inline friend bool operator<(const char  *lhs, cString     rhs) { return (strcmp(lhs, rhs)<0); }
	inline friend bool operator>(cString      lhs, cString     rhs) { return (strcmp(lhs, rhs)>0); }
	inline friend bool operator>(cString      lhs, const char *rhs) { return (strcmp(lhs, rhs)>0); }
	inline friend bool operator>(const char  *lhs, cString     rhs) { return (strcmp(lhs, rhs)>0); }
	inline friend bool operator<=(cString     lhs, cString     rhs) { return (strcmp(lhs, rhs)<=0); }
	inline friend bool operator<=(cString     lhs, const char *rhs) { return (strcmp(lhs, rhs)<=0); }
	inline friend bool operator<=(const char *lhs, cString     rhs) { return (strcmp(lhs, rhs)<=0); }
	inline friend bool operator>=(cString     lhs, cString     rhs) { return (strcmp(lhs, rhs)>=0); }
	inline friend bool operator>=(cString     lhs, const char *rhs) { return (strcmp(lhs, rhs)>=0); }
	inline friend bool operator>=(const char *lhs, cString     rhs) { return (strcmp(lhs, rhs)>=0); }
	inline friend bool operator==(cString     lhs, cString     rhs) { return ((lhs.Length() == rhs.Length()) && (memcmp(lhs, rhs, lhs.Length())==0)); }
	inline friend bool operator==(cString     lhs, const char *rhs) { return (memcmp(lhs, rhs, lhs.Length())==0); }
	inline friend bool operator==(const char *lhs, cString     rhs) { return (memcmp(lhs, rhs, rhs.Length())==0); }
	inline friend bool operator!=(cString     lhs, cString     rhs) { return ((lhs.Length() != rhs.Length()) || (memcmp(lhs, rhs, lhs.Length())!=0)); }
	inline friend bool operator!=(cString     lhs, const char *rhs) { return (memcmp(lhs, rhs, lhs.Length())!=0); }
	inline friend bool operator!=(const char *lhs, cString     rhs) { return (memcmp(lhs, rhs, rhs.Length())!=0); }

	//TODO finish this.. get text from a CWnd object.......
	void   SetWnd(void *w);
	String &GetWnd(void *w);
//	String &GetHWnd(long w);
	void   MsgBox();

	// Buffer allocation/copy/etc..
	void   AllocBuffer(long len, bool keep_contents=false);

	inline cString Copy(const char *src, long len)					{AllocBuffer(len);memcpy(pData,src,len-1);pData[len-1]=0;return *this;}
	inline cString Concat(const char *data, long len)				{if (len>0){long olen=Len;AllocBuffer(Len+len-1,true);memcpy(&pData[olen-1],data,len);}return *this;}
	protected:

	char   *pData;													// -> String data
	long	   Len;														// String length
	long	   Max;														// Space in data buffer
};


//
// Filename class, a superset of a String with functions to extract drive, path, etc.
//
DECLARE_CLASS(FileName);

enum
{
	GP_IS_PASTEND	=0,
	GP_IS_END		=1,
	GP_IS_BEFOREND	=2
};
class  FileName : public String
{
public:
	FileName()														: String() { }
	FileName(cString rhs)											: String(rhs) { }
	FileName(cFileName rhs)											: String(rhs) { }
	FileName(const char *name)										: String(name) { }
	inline cFileName operator=(cString rhs)							{ Copy(rhs.GetReadPtr(), rhs.Length()); return *this; }
	FileName BasePath() const;
	FileName BaseName() const;
	FileName Name(bool withext=true) const;
	FileName Extension() const;
	long GetPathLevel(String *t,short level);
	bool IsFullPath() const;
};



#endif





