/*
---------------------------------------------------------------------------
|					Special textfile IO
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#include "Library.h"
#include "TextFile.h"

//---------------------------------------------------------------------------
#define BUFLEN 1024

bool TextFileIO::GetLine(String &text)
{
	if (Opened && (Mode&mode_read))
	{
		char d=0;
		char buffer[BUFLEN+10];
		long i=0;
		while (Read(&d,1) && d!=0xa && i<BUFLEN && !IsEnd())
		{
			if (d==0xa || d==0xd)d=0;
			buffer[i]=d;
			i++;
		};
		buffer[i]=0;
		text=buffer;
		return(true);
	}
	return(false);
}

//---------------------------------------------------------------------------

bool TextFileIO::GetLine(long i,String &text)
{
	if (Opened && IsNonzero(Mode&mode_read))
	{
		Seek(0);
		long line=0;
		while (line<i)
		{
			char d=0;
			while (d!=0xa)
			{
				if (!Read(&d,1))return(false);
			}
			line++;
		};
		return (GetLine(text));
	}
	return(false);
}

//---------------------------------------------------------------------------

bool TextFileIO::SkipLine(long lines)
{
	if (Opened && IsNonzero(Mode&mode_read))
	{
		long line=0;
		while (line<lines)
		{
			char d=0;
			while (d!=0xa)
			{
				if (!Read(&d,1))return(false);
			}
			line++;
		};
		return(true);
	}
	return(false);
}

//---------------------------------------------------------------------------

bool TextFileIO::WriteLine(String &text)
{
	if (Opened && IsNonzero(Mode&mode_write))
	{
		char eol[3]={0xd,0xa,0};
		return (Write((char *)(text+eol),text.Length()+1));
	}
	return(false);
}

//---------------------------------------------------------------------------
