/*
---------------------------------------------------------------------------
|			  	 Some windows utils
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/ 
#include "Library.h"

//-------------------------------------------------------------------------

void CopyBitmap(CBitmap *src,CBitmap *dst)
{
	BITMAP p;
	
	src->GetBitmap(&p);
	dst->CreateBitmapIndirect(&p);
	
	long len=p.bmWidthBytes*p.bmHeight;
	char *data=new char[len];
	src->GetBitmapBits(len,data);
	dst->SetBitmapBits(len,data);
	delete data;
}

//-------------------------------------------------------------------------

 long CompareList(long i,...)
{
   long j=-2,t=0;
   va_list params;va_start(params, i);    
   while( j != -1 )
   {
	   j = va_arg( params, long);  
	   if (j==i)break;
	   t++;
   }
   va_end(params);
   return(t);
}

//-------------------------------------------------------------------------
// formatting message box
 void MsgBox(const char *fmt, ...)
{
	char buffer[2000];va_list params;va_start(params, fmt);    
	vsprintf(buffer,fmt,params);
	MessageBox(AfxGetMainWnd()->GetSafeHwnd(),buffer,"Message",MB_OK);
}

//-------------------------------------------------------------------------

 long	QstBox(long mode,const char *fmt, ...)
{
	char buffer[2000];va_list params;va_start(params, fmt);    
	vsprintf(buffer,fmt,params);
	
	long m;
	switch(mode)
	{
		case	MSB_YESNO:			 m=MB_YESNO;			break;
		case	MSB_OKCANCEL:		 m=MB_OKCANCEL;			break;
		case	MSB_YESNOCANCEL:	 m=MB_YESNOCANCEL;		break;
		case	MSB_RETRYCANCEL:	 m=MB_RETRYCANCEL;		break;
		case	MSB_ABORTRETRYIGNORE:m=MB_ABORTRETRYIGNORE;	break;
	};
	long r=AfxMessageBox(buffer,m);
	switch(r)
	{
		case	IDABORT:	return(MSB_ABORT);	break;
		case	IDCANCEL:	return(MSB_CANCEL);	break;
		case	IDIGNORE:	return(MSB_IGNORE);	break;
		case	IDNO:		return(MSB_NO);		break;
		case	IDOK:		return(MSB_OK);		break;
		case	IDRETRY:	return(MSB_RETRY);	break;
		case	IDYES:		return(MSB_YES);	break;
	};
	return(0);
};

//-------------------------------------------------------------------------


 void FmtCWnd(CWnd *wnd,const char *fmt, ...)
{
	char buffer[2000];va_list params;va_start(params, fmt);    
	vsprintf(buffer,fmt,params);wnd->SetWindowText(buffer);
}

//-------------------------------------------------------------------------
// Direct draw error helper
//---------------------------------------------------------------------------
// TODO.. make load,save and more functions for this..

 void	ClipCRect(CRect *rect,CRect *in,long x1,long y1,long x2,long y2)
{
	if (rect->left  <in->left  )rect->left  =in->left  +x1;
	if (rect->right >in->right )rect->right =in->right +x2;
	if (rect->top   <in->top   )rect->top   =in->top   +y1;
	if (rect->bottom>in->bottom)rect->bottom=in->bottom+y2;
}

//---------------------------------------------------------------------------

struct _richedbuf
{
	char *buf;
	long len;
	long pos;
};

static DWORD CALLBACK EditStreamInCallBack(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	_richedbuf *b=(_richedbuf *)dwCookie;

	if( (b->len-b->pos) < cb )
	{
		*pcb = b->len-b->pos;
		memcpy(pbBuff, (LPCSTR)&b->buf[b->pos], *pcb );
		b->pos+=*pcb;
	}
	else
	{
		*pcb = cb;
		memcpy(pbBuff, (LPCSTR)&b->buf[b->pos], *pcb );
		b->pos+=*pcb;
	}
	return 0;
}

//---------------------------------------------------------------------------

static DWORD CALLBACK EditStreamOutCallBack(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	_richedbuf *b=(_richedbuf *)dwCookie;

	if(b->pos<b->len)
	{
		if( (b->len-b->pos) < cb )
		{
			*pcb = b->len-b->pos;
			memcpy((void *)(LPCSTR)&b->buf[b->pos],pbBuff, *pcb );
			b->pos+=*pcb;
		}
		else
		{
			*pcb = cb;
			memcpy((void *)(LPCSTR)&b->buf[b->pos],pbBuff, *pcb );
			b->pos+=*pcb;
		}
	}
	return 0;
}

//---------------------------------------------------------------------------

 void UploadRichText(void *obj,void *data,long len,bool Selection)
{
	_richedbuf b;
	b.buf=(char *)data;
	b.len=len;b.pos=0;
	int f=SF_RTF;
	if (Selection)f|=SFF_SELECTION;
	EDITSTREAM es = {(DWORD)&b, 0, EditStreamInCallBack};
	((CRichEditCtrl *)obj)->StreamIn(f,es);
}

//---------------------------------------------------------------------------

 long DownloadRichText(void *obj,void *data,long len,bool Selection)
{
	_richedbuf b;
	b.buf=(char *)data;
	b.len=len;b.pos=0;
	int f=SF_RTF;
	if (Selection)f|=SFF_SELECTION;
	EDITSTREAM es = {(DWORD)&b, 0, EditStreamOutCallBack};
	((CRichEditCtrl *)obj)->StreamOut(f,es);
	return(b.pos);
}

//---------------------------------------------------------------------------

 void RegWriteLong(const char *section,const char *tag,const long value)
{
	MainWinAppPtr->WriteProfileInt(section,tag,value);
}

 void RegReadLong(const char *section,const char *tag,long &value,long def)
{
	value=MainWinAppPtr->GetProfileInt(section,tag,def);
}

 void RegWriteString(const char *section,const char *tag,const char *value)
{
	MainWinAppPtr->WriteProfileString(section,tag,value);
}

 void RegReadString(const char *section,const char *tag,String &value,const char *def)
{
	value=(char *)(LPCTSTR)MainWinAppPtr->GetProfileString(section,tag,def);
}
 void RegWriteFloat (const char *section,const char *tag,const float value)
{
	MainWinAppPtr->WriteProfileInt(section,tag,mfBin(value));
}
 void RegReadFloat  (const char *section,const char *tag,float &value,float def)
{
	value=mfFloat(MainWinAppPtr->GetProfileInt(section,tag,mfBin(def)));
};
 void RegWriteDouble(const char *section,const char *tag,const double value)
{
	RegWriteData(section,tag,(void *)&value,sizeof(double));
}
 void RegReadDouble (const char *section,const char *tag,double &value,double def)
{
	RegReadData(section,tag,(void *)&value,sizeof(double),&def);
}
 void RegWriteBool  (const char *section,const char *tag,const bool value)
{
	MainWinAppPtr->WriteProfileInt(section,tag,b2l(value));
}
 void RegReadBool   (const char *section,const char *tag,bool &value,bool def)
{
	value=l2b(MainWinAppPtr->GetProfileInt(section,tag,b2l(def)));
}
//---------------------------------------------------------------------------

 void RegWriteData  (const char *section,const char *tag,void *dat,long len)
{
	MainWinAppPtr->WriteProfileInt(section,tag,len);
	String t=tag;
	char *data=(char *)dat;
	if (len>0)
	{
		long dwd=len/4;
		long *ld=(long *)data;
		for (long i=0;i<dwd;i++)
		{
			MainWinAppPtr->WriteProfileInt(section,String(tag)+"_"+String(i),ld[i]);	
		}
		// write remaining bytes
		long lft=len%4;
		if (lft>0)
		{
			long dta=0;
			if (lft==1)dta=gMakeDWord(data[len-1],0,0,0);
			if (lft==2)dta=gMakeDWord(data[len-2],data[len-1],0,0);
			if (lft==3)dta=gMakeDWord(data[len-3],data[len-2],data[len-1],0);
			MainWinAppPtr->WriteProfileInt(section,String(tag)+"_l",dta);	
		}		
	}
}

//---------------------------------------------------------------------------

 bool RegReadData (const char *section,const char *tag,void *dat,long len,void *ldat)
{
	long loadlen=MainWinAppPtr->GetProfileInt(section,tag,0);
	if (loadlen==len && loadlen!=0)
	{
		String t=tag;
		char *data=(char *)dat;
		char *ldata=(char *)ldat;
		long dwd=len/4;
		long *ld=(long *)data;
		long *pd=(long *)ldata;
		for (long i=0;i<dwd;i++)
		{
			if (pd!=NULL)
				ld[i]=MainWinAppPtr->GetProfileInt(section,String(tag)+"_"+String(i),pd[i]);	
			else
				ld[i]=MainWinAppPtr->GetProfileInt(section,String(tag)+"_"+String(i),0);	
		}
		// read remaining bytes
		long lft=len%4;
		if (lft>0)
		{
			long dta=0,pdata=0;
			if (pd!=NULL) // preset data
			{
				if (lft==1)pdata=gMakeDWord(ldata[len-1],0,0,0);
				if (lft==2)pdata=gMakeDWord(ldata[len-2],ldata[len-1],0,0);
				if (lft==3)pdata=gMakeDWord(ldata[len-3],ldata[len-2],ldata[len-1],0);
			}
			dta=MainWinAppPtr->GetProfileInt(section,String(tag)+"_l",pdata);
			if (lft==1)data[len-1]=gLoByte(gLoWord(dta));
			if (lft==2)data[len-2]=gLoByte(gLoWord(dta)),data[len-1]=gHiByte(gLoWord(dta));
			if (lft==3)data[len-3]=gLoByte(gLoWord(dta)),data[len-2]=gHiByte(gLoWord(dta)),data[len-1]=gLoByte(gHiWord(dta));
		}		
		return(true);
	}
	else
	{
		return(false);
		for (long i=0;i<len;i++)((char *)dat)[i]=0;
	}
}

//---------------------------------------------------------------------------

 HTREEITEM CTreeWalk(CTreeCtrl *t,HTREEITEM hItem,HTREEITEM start,short *level)
{	
	HTREEITEM i,p=hItem;
	i=t->GetChildItem(hItem);
	if (i!=NULL){if (level!=NULL)*level++;return(i);}
	i=t->GetNextSiblingItem(hItem);
	if (i!=NULL)return(i);
	while (i==NULL)
	{
		if (level!=NULL)*level--;
		p=t->GetParentItem(p);
		if (p==NULL)return(p);
		if (p==start)return(NULL);
		i=t->GetNextSiblingItem(p);
	}
	return(i);
}


//--------------------------------------------------------------------------------------------

 void move_winptrwindow(void *window,long x,long y,long xs,long ys)
{
	// now get original x,y,xs,ys
	if (window!=NULL)
	{
		CWnd *win=(CWnd *)window;
		CRect rct,sz;
		win->GetClientRect(rct);
		if (x!=-1) rct.left   =x;
		if (y!=-1) rct.top    =y;
		win->GetWindowRect(sz);
		rct.right=rct.left+sz.right-sz.left;
		rct.bottom=rct.top+sz.bottom-sz.top;
		if (xs!=-1)rct.right  =xs;//+(sz.right-sz.left);
		if (ys!=-1)rct.bottom =ys;//+(sz.bottom-sz.top);
		win->MoveWindow(rct);	
	}
}

//--------------------------------------------------------------------------------------------

 void close_winptrwindow(void **window)
{
	if (window!=NULL && *window!=NULL)
	{
		((CDialogTool *)(*window))->ShutdownDialog();
		*window=NULL;
	}
}

//--------------------------------------------------------------------------------------------

 bool toggle_winptrwindow(void *window)
{
	if (window!=NULL)
	{
		return(((CDialogTool *)(window))->ToggleWin());
	}
	return(false);
}

//--------------------------------------------------------------------------------------------

 void sendmessage_winptr(void *window,long msg,long data1,long data2)
{
	if (window!=NULL)
	{
		((CDialogTool *)(window))->message_handler(msg,data1,data2);
	}
}

//--------------------------------------------------------------------------------------------

 void ComboBoxAddSep(String &data,void *cmb,char delim)
{
	CComboBox &box=*(CComboBox *)cmb;
	char *c=data.GetPtr();

	for (long i=0,j=0;;i++)
	{
		if (i==data.Length() || c[i]=='|')
		{
			String t=data.Mid(j,i-j+1)+"\0";
			box.AddString(t);
			j=i+1;
		}
		if (i>=data.Length())break;
	}
}

//--------------------------------------------------------------------------------------------

 void BB2ToCRect(void *in, void *out)
{
	CRect &tgt=*(CRect*)out;
	BoundingBox2 &src=*(BoundingBox2*)in;
	tgt.left=src.Min.x,tgt.top=src.Min.y,tgt.right=src.Max.x,tgt.bottom=src.Max.y;
}

//--------------------------------------------------------------------------------------------

 void CRectToBB2(void *in, void *out)
{
	CRect &src=*(CRect*)in;
	BoundingBox2 &tgt=*(BoundingBox2*)out;
	tgt.Min.x=src.left,
		tgt.Min.y=src.top,
		tgt.Max.x=src.right,
		tgt.Max.y=src.bottom;
}
