/*
---------------------------------------------------------------------------
|					Windows utils
|				  Copyright (C) 1998 VF Technologies 
|	 					Code: Rik Arends
|						All Rights Reserved
---------------------------------------------------------------------------
*/
#ifndef _H_WINUTIL
#define _H_WINUTIL

// Logging window functions
extern  void OpenLogwindow(CWnd *parent);
extern  void CloseLogwindow();
extern  void *winptr_log;

// Debug window functions....
extern  void OpenDebugwindow(CWnd *parent);
extern  void CloseDebugwindow(); // permanently closes the debug window.. not just hide
extern  void *winptr_debug;

// other generic windows
extern  bool OpenPopupMenu(CWnd* pParent,short *rval,CMenu *menu, CPoint *origin);
extern  bool OpenInputDlg(CWnd *parent,String *obj,const char *title="Input");

// Generic window helpers
extern  void close_winptrwindow(void **window);
extern  void move_winptrwindow(void *window,long x=-1,long y=-1,long xs=-1,long ys=-1);
extern  bool toggle_winptrwindow(void *window); // returns true if opened
extern  void sendmessage_winptr(void *window,long msg,long data1=0,long data2=0); // calls the 'sendmessage' overload for the dialog class

// Progress window shite
extern  void ProgressWindowOpen(char *title,char *frame, bool showtime);
extern  void ProgressWindowClose();
extern  void ProgressWindowSet(char *report,float fac);
extern  void ProgressWindowTween(char *tween);


// Registry helpers
extern  void RegWriteLong  (const char *section,const char *tag,const long value); 
extern  void RegReadLong   (const char *section,const char *tag,long &value,long def=0);
extern  void RegWriteFloat (const char *section,const char *tag,const float value); 
extern  void RegReadFloat  (const char *section,const char *tag,float &value,float def=0);
extern  void RegWriteDouble(const char *section,const char *tag,const double value); 
extern  void RegReadDouble (const char *section,const char *tag,double &value,double def=0);
extern  void RegWriteBool  (const char *section,const char *tag,const bool value); 
extern  void RegReadBool   (const char *section,const char *tag,bool &value,bool def=false);
extern  void RegWriteString(const char *section,const char *tag,const char *value);
extern  void RegReadString (const char *section,const char *tag,String &value,const char *def="\0");
extern  void RegWriteData  (const char *section,const char *tag,void *data,long len);
extern  bool RegReadData   (const char *section,const char *tag,void *data,long len,void *pdata=NULL);
// Global utilities (mostly MFC based)
extern  long CompareList(long i,...);
extern  void	MsgBox(const char *fmt, ...);
enum // question box	
{	
	MSB_YESNO				=0,
	MSB_OKCANCEL			=1,
	MSB_YESNOCANCEL			=2,
	MSB_RETRYCANCEL			=3,
	MSB_ABORTRETRYIGNORE	=4,

	MSB_YES					=5,
	MSB_NO					=6,
	MSB_OK					=7,
	MSB_CANCEL				=8,
	MSB_IGNORE				=8,
	MSB_ABORT				=9,
	MSB_RETRY				=10
};
extern  long	QstBox(long mode,const char *fmt, ...);
extern  void	FmtCWnd(CWnd *obj,const char *fmt, ...);
extern  void CopyBitmap(CBitmap *src,CBitmap *dst);
extern  void	ClipCRect(CRect *rect,CRect *in,long x1=0,long y1=0,long x2=0,long y2=0);
extern  void UploadRichText(void *obj,void *data,long len,bool Selection=false);
extern  long DownloadRichText(void *obj,void *data,long len,bool Selection=false);
extern  void ComboBoxAddSep(String &data,void *cmb,char delim='|');
extern  void BB2ToCRect(void *in, void *out);
extern  void CRectToBB2(void *in, void *out);
extern  HTREEITEM CTreeWalk(CTreeCtrl *t,HTREEITEM hItem,HTREEITEM start=NULL,short *level=NULL);

#endif