// vfcalcDlg.h : header file
//

#if !defined(AFX_VFCALCDLG_H__046AC088_9064_11D2_B794_DE97EF125D2D__INCLUDED_)
#define AFX_VFCALCDLG_H__046AC088_9064_11D2_B794_DE97EF125D2D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CVfcalcDlg dialog
//#define _T_NEDERLANDS
#define _T_ENGLISH

enum
{	
	_CT_CALC =0, 
	_CT_FX	 =1,	// gives three function drawing things.. just plain f(x)
	_CT_FT	 =2,	// gives paramter functions
	_CT_FXY	 =3,	// draws 
	_CT_FXYIM=4,	// 2D Heightmap..
	_CT_FT3D =5,	// 3d xyz parameter function..
	_CT_EQ	 =6,     // Equation
	_CT_FTS	 =7,		// Sound f(t)
};

enum
{
	_COL_BW		=0,
	_COL_GREEN	=1,
	_COL_BLUE	=2,
	_COL_WB		=3
};

#define NDIGITS 15 // number of digits in nummerical output

//#define _CMP_FASTDRAW

#include "mmsystem.h"

class CVfcalcDlg : public CDialogTool
{
// Construction
public:
	CVfcalcDlg(CWnd* pParent = NULL);	// standard constructor

	// Clipboard stuff
	HBITMAP hclipboardbitmap;
	bool	clipboardloaded;
	bool	ToClipboard;

	// Mouse moveing options
	short MouseMoveMode;
	CPoint MouseOrigin;
	CPoint LastMouse;

	void MouseSlidePopup(CPoint *where);
	void MouseSlide(double delta,double &val);

	class switches 
	{
		public:
		switches()
		{
			nor_a=true,nor_b=false,nor_c=false;
			der_a=false,der_b=false,der_c=false;
			der2_a=false,der2_b=false,der2_c=false;
			int_a=false,int_b=false,int_c=false;
			len_a=false,len_b=false,len_c=false;		
			FixParam=false;
			Animate=false;
			Rotate=false;
			OnHold=false;
			ShowNum=true;
			Asm	   =true;
		};
		~switches(){};
	
		bool nor_a,nor_b,nor_c;
		bool der_a,der_b,der_c;
		bool der2_a,der2_b,der2_c;
		bool len_a,len_b,len_c;
		bool int_a,int_b,int_c;
		bool FixParam;
		bool ShowNum;
		bool Asm;
		bool Rotate;
		bool Animate;
		bool OnHold;

		friend	rArchive operator<<(rArchive arc, switches &b) // starting point for serialization
		{
			arc<<b.nor_a<<b.nor_b<<b.nor_c<<b.der_a<<b.der_b<<b.der_c<<b.der2_a<<b.der2_b<<b.der2_c<<b.len_a<<b.len_b<<b.len_c;
			arc<<b.int_a<<b.int_b<<b.int_c<<b.FixParam<<b.Rotate<<b.Animate<<b.OnHold<<b.ShowNum;
			return(arc);
		}
		friend	rArchive operator>>(rArchive arc, switches &b)
		{
			arc>>b.nor_a>>b.nor_b>>b.nor_c>>b.der_a>>b.der_b>>b.der_c>>b.der2_a>>b.der2_b>>b.der2_c>>b.len_a>>b.len_b>>b.len_c;
			arc>>b.int_a>>b.int_b>>b.int_c>>b.FixParam>>b.Rotate>>b.Animate>>b.OnHold>>b.ShowNum;
			return(arc);
		};
		void Set(CVfcalcDlg *x);
	}sw;

	class variables
	{
		public:
		variables(){};
		inline void Reset()
		{
			slidemode=0;
			a=b=c=d=f=g=h=j=k=l=m=0;
			dt1=-5,dt2=5;
			dt3=-5,dt4=5;
			gridfac=50,stepsize=0.001f;
			parx=0,pary=0;
			xpos=-10;
			ypos=0;
			fscale=1,fclip=0;
			xscale=0.04;
			yscale=0.04;

			CalcType=1;
			SubType=0;
			colormode=0;
			accuracy=13;
			
			AnimN=0;
			StartTime=GetTime();

			viewrotate.x=-60;viewrotate.y=0;viewrotate.z=0;
			viewdistance=30;	
			outputmode=0;
		}
		~variables(){};
		friend	rArchive operator<<(rArchive arc, variables &x) // starting point for serialization
		{
			arc<<x.a<<x.b<<x.c<<x.d<<x.f<<x.g<<x.h<<x.j<<x.k<<x.l<<x.m;
			arc<<x.dt1<<x.dt2<<x.dt3<<x.dt4<<x.gridfac<<x.stepsize<<x.parx<<x.pary;
			arc<<x.xpos<<x.ypos<<x.xscale<<x.yscale<<x.fscale<<x.fclip<<x.CalcType<<x.SubType<<x.outputmode<<x.colormode;
			arc<<x.accuracy<<x.acc<<x.AnimN<<x.viewrotate<<x.viewdistance<<x.outputmode<<x.slidemode;
			return(arc);
		}
		friend	rArchive operator>>(rArchive arc, variables &x)
		{
			arc>>x.a>>x.b>>x.c>>x.d>>x.f>>x.g>>x.h>>x.j>>x.k>>x.l>>x.m;
			arc>>x.dt1>>x.dt2>>x.dt3>>x.dt4>>x.gridfac>>x.stepsize>>x.parx>>x.pary;
			arc>>x.xpos>>x.ypos>>x.xscale>>x.yscale>>x.fscale>>x.fclip>>x.CalcType>>x.SubType>>x.outputmode>>x.colormode;
			arc>>x.accuracy>>x.acc>>x.AnimN>>x.viewrotate>>x.viewdistance>>x.outputmode>>x.slidemode;
			return(arc);
		}

		void Set(CVfcalcDlg *x);
		short slidemode; // 0-def 1-0.00001 2- 0.0001 3-0.001 4-0.01 5-0.1 6-1 7-10 8-100 9-1000 10-10000 11- 100000 12-log
		short CalcType;
		short SubType; 
		short colormode;
		short outputmode;

		// timing variables
		double AnimN; 
		double StartTime;
		// accuracy
		double accuracy;
		double acc; // calculated accuracy = pow(10,-accuracy);

		double  a,b,c,d,f,g,h,j,k,l,m; // letter variables
		double  dt1,dt2,dt3,dt4; // external domain stuff
		double  gridfac,stepsize,parx,pary;
		double  xpos,ypos,xscale,yscale,fscale,fclip;
		Vector3 viewrotate;
		float   viewdistance;
	}var;

	class functions
	{
		public:
			functions(){a="";b="";c="";k="";l="";m="";}
		String a,b,c,k,l,m;	
		FuncAsm fa,fb,fc,fk,fl,fm;
		inline void SetVar(char var,double val)	{fa.SetVariable(var,val);fb.SetVariable(var,val);fc.SetVariable(var,val);fk.SetVariable(var,val);fl.SetVariable(var,val);fm.SetVariable(var,val);}
		friend	rArchive operator<<(rArchive arc, functions &x) // starting point for serialization
		{
			arc<<x.a<<x.b<<x.c<<x.k<<x.l<<x.m;
			return(arc);
		}
		friend	rArchive operator>>(rArchive arc, functions &x)
		{
			arc>>x.a>>x.b>>x.c>>x.k>>x.l>>x.m;
			x.fa.Create(x.a);
			x.fb.Create(x.b);
			x.fc.Create(x.c);
			x.fk.Create(x.k);
			x.fl.Create(x.l);
			x.fm.Create(x.m);
			return(arc);
		}
		void Set(CVfcalcDlg *x);
	}func;
	MultithreadLock FuncLock;
	void ReparseFunction(short w=-1);
	void Recalc();

	class colors
	{
		public:
		colors(){};
		~colors(){};
		COLORREF text;
		COLORREF line1;
		COLORREF line2;
		COLORREF line3;
		COLORREF axes;
		COLORREF grid;
		COLORREF back;
		COLORREF point;
	}col;

	void UpdateType(); // hides unhides window items according to calctype..

	void UpdateNumbers(double x,double y);// updates numbers in nummerical view

	bool LoadFile(String *filename);
	bool SaveFile(String *filename);

	double clipf(double v);

	// Sound stuff
	class SoundOutput
	{
		public:
		#define MINIMUMBLOCKTIMING 0.1
		#define MAXIMUMBLOCKTIMING 1

		SoundOutput()
		{
			buftime=0.2;
			active=false;
		};
		~SoundOutput(){};
		bool		active;
		bool	    updating;
		HWAVEOUT	hWaveOut;
		WAVEHDR		WaveHdr1,WaveHdr2,*WaveHdr,*WaveHdrSwap;
		WAVEFORMATEX wf;
		char		*bufback;
		char		*bufplay;
		long	    buflen; // in 'samples'
		long		bufsize;// in 'bytes'
		double		buftime;
		double		time;
		long		buftype;

	}snd;
	void		OpenSound();
	void		CloseSound();

	class DrawData
	{
		public:
		DrawData(){};~DrawData(){};
		void Setup(CVfcalcDlg *o);
		void Delete();
		// Window variables
		double w_start,w_end,w_mid,w_min,w_max,w_width,w_height;
		double f_start, f_end,f_min,f_max;
		double ftow_xscale,ftow_xoffset,ftow_yscale,ftow_yoffset;
		CPen p_line1,p_line2,p_line3,p_axes,p_grid;
		CBrush b_back;
		CFont t_textl;
		CFont t_texts;
		CRect DrawFrame;
		CDC *dc;
		CDC *odc;
	}dd;

	class CalcMode
	{
		public:
		CalcMode(CVfcalcDlg *o)
		{
			vc=o;
			HasNoBackBuffer=false;
			HasSoundReset=false;
			HasSlideOnShift=false;
			Has3DControl=false;
		};

		virtual ~CalcMode(){};
		
		virtual void SetControls(){};
		virtual void ShowNumbers(double x,double y){};
		virtual void Draw(){};

		virtual void Initialize(){};
		virtual void Shutdown(){}; 
		virtual void Resize(){};

		CVfcalcDlg *vc;

		// Mode options
		bool Has2DBackground;
		bool HasSlideOnShift;
		bool Has3DControl;
		bool HasSoundReset;
		bool HasNoBackBuffer;
	};
	double lasttime;

	CalcMode *CalcObj;

	//#ifdef _T_NEDERLANDS
	//enum { IDD = IDD_VFCALC_DIALOGNEDERLANDS };
	//#endif
	//#ifdef _T_ENGLISH
	enum { IDD = IDD_VFCALC_DIALOG };
	//#endif

	// Dialog Data
	//{{AFX_DATA(CVfcalcDlg)
	//enum { IDD = IDD_VFCALC_DIALOG };
	CButton	m_AddC;
	CButton	m_AddB;
	CButton	m_AddA;
	CComboBox	m_FuncCM;
	CComboBox	m_FuncCL;
	CComboBox	m_FuncCK;
	CEdit	m_ViewY;
	CEdit	m_ViewC;
	CEdit	m_ViewB;
	CEdit	m_ViewA;
	CEdit	m_ViewX;
	CComboBox	m_FuncCC;
	CComboBox	m_FuncCB;
	CComboBox	m_FuncCA;
	CComboBox	m_ViewSubType;
	CStatic	m_SldAc;
	CEdit	m_Accuracy;
	CStatic	m_SldFS;
	CStatic	m_SldFC;
	CStatic	m_DomainView;
	CEdit	m_FuncScale;
	CEdit	m_FuncClip;
	CButton	m_Rotate;
	CButton	m_Animate;
	CButton	m_Length_C;
	CButton	m_Length_B;
	CButton	m_Length_A;
	CButton	m_Derive2_C;
	CButton	m_Derive2_B;
	CButton	m_Derive2_A;
	CButton	m_FrameViewOptions;
	CButton	m_FrameValue;
	CButton	m_FrameFunction;
	CButton	m_FrameFixParam;
	CStatic	m_FixParamX;
	CStatic	m_SldPY;
	CStatic	m_SldPX;
	CEdit	m_ParamY;
	CEdit	m_ParamX;
	CButton	m_FixParam;
	CEdit	m_DomT4;
	CEdit	m_DomT3;
	CStatic	m_SldD4;
	CStatic	m_SldD3;
	CStatic	m_DomainTitle;
	CStatic	m_FOPy;
	CStatic	m_FOPx;
	CStatic	m_FOPreTypeC;
	CStatic	m_FOPreTypeB;
	CStatic	m_FOPreTypeA;
	CStatic	m_FPreTypeC;
	CStatic	m_FPreTypeB;
	CStatic	m_FPreTypeA;
	CComboBox	m_ViewType;
	CComboBox	m_ColorMode;
	CStatic	m_DrawFrame;
	CEdit	m_Step;
	CEdit	m_EdD;
	CStatic	m_SldStep;
	CStatic	m_SldGrid;
	CStatic	m_SldD2;
	CStatic	m_SldD1;
	CStatic	m_SldJ;
	CStatic	m_SldH;
	CStatic	m_SldG;
	CStatic	m_SldF;
	CStatic	m_SldD;
	CStatic	m_SldC;
	CStatic	m_SldB;
	CStatic	m_SldA;
	CEdit	m_YS;
	CEdit	m_XS;
	CEdit	m_Grid;
	CEdit	m_DomT2;
	CEdit	m_DomT1;
	CEdit	m_EdJ;
	CEdit	m_EdH;
	CEdit	m_EdG;
	CEdit	m_EdF;
	CEdit	m_EdC;
	CEdit	m_EdB;
	CEdit	m_EdA;
	CButton	m_Derive_C;
	CButton	m_Derive_B;
	CButton	m_Derive_A;
	CButton	m_Int_C;
	CButton	m_Int_B;
	CButton	m_Int_A;
	CButton	m_Normal_C;
	CButton	m_Normal_B;
	CButton	m_Normal_A;
	CButton	m_ShowNum;
	CButton	m_Asm;
	CComboBox	m_CalcType;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVfcalcDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVfcalcDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSelchangeCalctype();
	afx_msg void OnNormalA();
	afx_msg void OnNormalB();
	afx_msg void OnNormalC();
	afx_msg void OnIntegralA();
	afx_msg void OnIntegralB();
	afx_msg void OnIntegralC();
	afx_msg void OnDeriveA();
	afx_msg void OnDeriveB();
	afx_msg void OnDeriveC();
	afx_msg void OnChangeAEdit();
	afx_msg void OnChangeBEdit();
	afx_msg void OnChangeCEdit();
	afx_msg void OnChangeDEdit();
	afx_msg void OnChangeFEdit();
	afx_msg void OnChangeGEdit();
	afx_msg void OnChangeHEdit();
	afx_msg void OnChangeJEdit();
	afx_msg void OnChangeT1();
	afx_msg void OnChangeT2();
	afx_msg void OnCentre();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChangeGridedit();
	afx_msg void OnChangeStepedit();
	afx_msg void OnSelchangeColormode();
	afx_msg void OnChangeXsedit();
	afx_msg void OnChangeYsedit();
	afx_msg void OnSelchangeViewtype();
	afx_msg void OnChangeT4();
	afx_msg void OnChangeT3();
	afx_msg void OnFixparam();
	afx_msg void OnChangeParamx();
	afx_msg void OnChangeParamy();
	afx_msg void OnDerive2A();
	afx_msg void OnDerive2B();
	afx_msg void OnDerive2C();
	afx_msg void OnLengthA();
	afx_msg void OnLengthB();
	afx_msg void OnLengthC();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnAnimate();
	afx_msg void OnRotate();
	afx_msg void OnReset();
	afx_msg void OnChangeFuncclip();
	afx_msg void OnChangeFuncscale();
	afx_msg void OnSelchangeViewsubtype();
	afx_msg void OnChangeAccuracy();
	afx_msg void OnSelchangeFuncedc();
	afx_msg void OnSelchangeFuncedb();
	afx_msg void OnSelchangeFunceda();
	afx_msg void OnEditchangeFunceda();
	afx_msg void OnEditchangeFuncedb();
	afx_msg void OnEditchangeFuncedc();
	afx_msg void OnAdda();
	afx_msg void OnAddb();
	afx_msg void OnAddc();
	afx_msg void OnSave();
	afx_msg void OnLoad();
	afx_msg void OnFreset();
	afx_msg void OnEditchangeFuncedk();
	afx_msg void OnSelchangeFuncedk();
	afx_msg void OnEditchangeFuncedl();
	afx_msg void OnSelchangeFuncedl();
	afx_msg void OnEditchangeFuncedm();
	afx_msg void OnSelchangeFuncedm();
	afx_msg void OnHelpme();
	afx_msg void OnToclipboard();
	afx_msg void OnShownum();
	afx_msg void OnAsmOptimize();
	afx_msg void OnMove(int x, int y);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnStnClickedDomaintitle();
public:
	afx_msg void OnEnChangeViewEb();
public:
	afx_msg void OnStnClickedFuncoutpretype1();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VFCALCDLG_H__046AC088_9064_11D2_B794_DE97EF125D2D__INCLUDED_)
